/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(3D_CANVAS)

#include "JSWebGLRenderingContext.h"

#include "JSWebGLActiveInfo.h"
#include "JSWebGLArray.h"
#include "JSWebGLBuffer.h"
#include "JSWebGLContextAttributes.h"
#include "JSWebGLFramebuffer.h"
#include "JSWebGLProgram.h"
#include "JSWebGLRenderbuffer.h"
#include "JSWebGLShader.h"
#include "JSWebGLTexture.h"
#include "JSWebGLUniformLocation.h"
#include "KURL.h"
#include "WebGLActiveInfo.h"
#include "WebGLArray.h"
#include "WebGLBuffer.h"
#include "WebGLContextAttributes.h"
#include "WebGLFramebuffer.h"
#include "WebGLProgram.h"
#include "WebGLRenderbuffer.h"
#include "WebGLRenderingContext.h"
#include "WebGLShader.h"
#include "WebGLTexture.h"
#include "WebGLUniformLocation.h"
#include <runtime/Error.h>
#include <runtime/JSNumberCell.h>
#include <runtime/JSString.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

ASSERT_CLASS_FITS_IN_CELL(JSWebGLRenderingContext);

/* Hash table */

static const HashTableValue JSWebGLRenderingContextTableValues[2] =
{
    { "constructor", DontEnum|ReadOnly, (intptr_t)jsWebGLRenderingContextConstructor, (intptr_t)0 },
    { 0, 0, 0, 0 }
};

static JSC_CONST_HASHTABLE HashTable JSWebGLRenderingContextTable =
#if ENABLE(PERFECT_HASH_SIZE)
    { 0, JSWebGLRenderingContextTableValues, 0 };
#else
    { 2, 1, JSWebGLRenderingContextTableValues, 0 };
#endif

/* Hash table for constructor */

static const HashTableValue JSWebGLRenderingContextConstructorTableValues[303] =
{
    { "DEPTH_BUFFER_BIT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDEPTH_BUFFER_BIT, (intptr_t)0 },
    { "STENCIL_BUFFER_BIT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_BUFFER_BIT, (intptr_t)0 },
    { "COLOR_BUFFER_BIT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCOLOR_BUFFER_BIT, (intptr_t)0 },
    { "FALSE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFALSE, (intptr_t)0 },
    { "TRUE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTRUE, (intptr_t)0 },
    { "POINTS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextPOINTS, (intptr_t)0 },
    { "LINES", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLINES, (intptr_t)0 },
    { "LINE_LOOP", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLINE_LOOP, (intptr_t)0 },
    { "LINE_STRIP", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLINE_STRIP, (intptr_t)0 },
    { "TRIANGLES", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTRIANGLES, (intptr_t)0 },
    { "TRIANGLE_STRIP", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTRIANGLE_STRIP, (intptr_t)0 },
    { "TRIANGLE_FAN", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTRIANGLE_FAN, (intptr_t)0 },
    { "ZERO", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextZERO, (intptr_t)0 },
    { "ONE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextONE, (intptr_t)0 },
    { "SRC_COLOR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSRC_COLOR, (intptr_t)0 },
    { "ONE_MINUS_SRC_COLOR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextONE_MINUS_SRC_COLOR, (intptr_t)0 },
    { "SRC_ALPHA", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSRC_ALPHA, (intptr_t)0 },
    { "ONE_MINUS_SRC_ALPHA", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextONE_MINUS_SRC_ALPHA, (intptr_t)0 },
    { "DST_ALPHA", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDST_ALPHA, (intptr_t)0 },
    { "ONE_MINUS_DST_ALPHA", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextONE_MINUS_DST_ALPHA, (intptr_t)0 },
    { "DST_COLOR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDST_COLOR, (intptr_t)0 },
    { "ONE_MINUS_DST_COLOR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextONE_MINUS_DST_COLOR, (intptr_t)0 },
    { "SRC_ALPHA_SATURATE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSRC_ALPHA_SATURATE, (intptr_t)0 },
    { "FUNC_ADD", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFUNC_ADD, (intptr_t)0 },
    { "BLEND_EQUATION", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBLEND_EQUATION, (intptr_t)0 },
    { "BLEND_EQUATION_RGB", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBLEND_EQUATION_RGB, (intptr_t)0 },
    { "BLEND_EQUATION_ALPHA", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBLEND_EQUATION_ALPHA, (intptr_t)0 },
    { "FUNC_SUBTRACT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFUNC_SUBTRACT, (intptr_t)0 },
    { "FUNC_REVERSE_SUBTRACT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFUNC_REVERSE_SUBTRACT, (intptr_t)0 },
    { "BLEND_DST_RGB", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBLEND_DST_RGB, (intptr_t)0 },
    { "BLEND_SRC_RGB", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBLEND_SRC_RGB, (intptr_t)0 },
    { "BLEND_DST_ALPHA", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBLEND_DST_ALPHA, (intptr_t)0 },
    { "BLEND_SRC_ALPHA", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBLEND_SRC_ALPHA, (intptr_t)0 },
    { "CONSTANT_COLOR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCONSTANT_COLOR, (intptr_t)0 },
    { "ONE_MINUS_CONSTANT_COLOR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextONE_MINUS_CONSTANT_COLOR, (intptr_t)0 },
    { "CONSTANT_ALPHA", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCONSTANT_ALPHA, (intptr_t)0 },
    { "ONE_MINUS_CONSTANT_ALPHA", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextONE_MINUS_CONSTANT_ALPHA, (intptr_t)0 },
    { "BLEND_COLOR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBLEND_COLOR, (intptr_t)0 },
    { "ARRAY_BUFFER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextARRAY_BUFFER, (intptr_t)0 },
    { "ELEMENT_ARRAY_BUFFER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextELEMENT_ARRAY_BUFFER, (intptr_t)0 },
    { "ARRAY_BUFFER_BINDING", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextARRAY_BUFFER_BINDING, (intptr_t)0 },
    { "ELEMENT_ARRAY_BUFFER_BINDING", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextELEMENT_ARRAY_BUFFER_BINDING, (intptr_t)0 },
    { "STREAM_DRAW", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTREAM_DRAW, (intptr_t)0 },
    { "STATIC_DRAW", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTATIC_DRAW, (intptr_t)0 },
    { "DYNAMIC_DRAW", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDYNAMIC_DRAW, (intptr_t)0 },
    { "BUFFER_SIZE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBUFFER_SIZE, (intptr_t)0 },
    { "BUFFER_USAGE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBUFFER_USAGE, (intptr_t)0 },
    { "CURRENT_VERTEX_ATTRIB", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCURRENT_VERTEX_ATTRIB, (intptr_t)0 },
    { "FRONT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRONT, (intptr_t)0 },
    { "BACK", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBACK, (intptr_t)0 },
    { "FRONT_AND_BACK", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRONT_AND_BACK, (intptr_t)0 },
    { "TEXTURE_2D", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_2D, (intptr_t)0 },
    { "CULL_FACE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCULL_FACE, (intptr_t)0 },
    { "BLEND", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBLEND, (intptr_t)0 },
    { "DITHER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDITHER, (intptr_t)0 },
    { "STENCIL_TEST", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_TEST, (intptr_t)0 },
    { "DEPTH_TEST", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDEPTH_TEST, (intptr_t)0 },
    { "SCISSOR_TEST", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSCISSOR_TEST, (intptr_t)0 },
    { "POLYGON_OFFSET_FILL", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextPOLYGON_OFFSET_FILL, (intptr_t)0 },
    { "SAMPLE_ALPHA_TO_COVERAGE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSAMPLE_ALPHA_TO_COVERAGE, (intptr_t)0 },
    { "SAMPLE_COVERAGE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSAMPLE_COVERAGE, (intptr_t)0 },
    { "NO_ERROR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextNO_ERROR, (intptr_t)0 },
    { "INVALID_ENUM", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextINVALID_ENUM, (intptr_t)0 },
    { "INVALID_VALUE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextINVALID_VALUE, (intptr_t)0 },
    { "INVALID_OPERATION", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextINVALID_OPERATION, (intptr_t)0 },
    { "OUT_OF_MEMORY", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextOUT_OF_MEMORY, (intptr_t)0 },
    { "CW", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCW, (intptr_t)0 },
    { "CCW", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCCW, (intptr_t)0 },
    { "LINE_WIDTH", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLINE_WIDTH, (intptr_t)0 },
    { "ALIASED_POINT_SIZE_RANGE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextALIASED_POINT_SIZE_RANGE, (intptr_t)0 },
    { "ALIASED_LINE_WIDTH_RANGE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextALIASED_LINE_WIDTH_RANGE, (intptr_t)0 },
    { "CULL_FACE_MODE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCULL_FACE_MODE, (intptr_t)0 },
    { "FRONT_FACE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRONT_FACE, (intptr_t)0 },
    { "DEPTH_RANGE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDEPTH_RANGE, (intptr_t)0 },
    { "DEPTH_WRITEMASK", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDEPTH_WRITEMASK, (intptr_t)0 },
    { "DEPTH_CLEAR_VALUE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDEPTH_CLEAR_VALUE, (intptr_t)0 },
    { "DEPTH_FUNC", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDEPTH_FUNC, (intptr_t)0 },
    { "STENCIL_CLEAR_VALUE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_CLEAR_VALUE, (intptr_t)0 },
    { "STENCIL_FUNC", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_FUNC, (intptr_t)0 },
    { "STENCIL_FAIL", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_FAIL, (intptr_t)0 },
    { "STENCIL_PASS_DEPTH_FAIL", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_PASS_DEPTH_FAIL, (intptr_t)0 },
    { "STENCIL_PASS_DEPTH_PASS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_PASS_DEPTH_PASS, (intptr_t)0 },
    { "STENCIL_REF", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_REF, (intptr_t)0 },
    { "STENCIL_VALUE_MASK", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_VALUE_MASK, (intptr_t)0 },
    { "STENCIL_WRITEMASK", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_WRITEMASK, (intptr_t)0 },
    { "STENCIL_BACK_FUNC", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_BACK_FUNC, (intptr_t)0 },
    { "STENCIL_BACK_FAIL", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_BACK_FAIL, (intptr_t)0 },
    { "STENCIL_BACK_PASS_DEPTH_FAIL", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_BACK_PASS_DEPTH_FAIL, (intptr_t)0 },
    { "STENCIL_BACK_PASS_DEPTH_PASS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_BACK_PASS_DEPTH_PASS, (intptr_t)0 },
    { "STENCIL_BACK_REF", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_BACK_REF, (intptr_t)0 },
    { "STENCIL_BACK_VALUE_MASK", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_BACK_VALUE_MASK, (intptr_t)0 },
    { "STENCIL_BACK_WRITEMASK", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_BACK_WRITEMASK, (intptr_t)0 },
    { "VIEWPORT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextVIEWPORT, (intptr_t)0 },
    { "SCISSOR_BOX", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSCISSOR_BOX, (intptr_t)0 },
    { "COLOR_CLEAR_VALUE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCOLOR_CLEAR_VALUE, (intptr_t)0 },
    { "COLOR_WRITEMASK", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCOLOR_WRITEMASK, (intptr_t)0 },
    { "UNPACK_ALIGNMENT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextUNPACK_ALIGNMENT, (intptr_t)0 },
    { "PACK_ALIGNMENT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextPACK_ALIGNMENT, (intptr_t)0 },
    { "MAX_TEXTURE_SIZE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMAX_TEXTURE_SIZE, (intptr_t)0 },
    { "MAX_VIEWPORT_DIMS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMAX_VIEWPORT_DIMS, (intptr_t)0 },
    { "SUBPIXEL_BITS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSUBPIXEL_BITS, (intptr_t)0 },
    { "RED_BITS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRED_BITS, (intptr_t)0 },
    { "GREEN_BITS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextGREEN_BITS, (intptr_t)0 },
    { "BLUE_BITS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBLUE_BITS, (intptr_t)0 },
    { "ALPHA_BITS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextALPHA_BITS, (intptr_t)0 },
    { "DEPTH_BITS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDEPTH_BITS, (intptr_t)0 },
    { "STENCIL_BITS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_BITS, (intptr_t)0 },
    { "POLYGON_OFFSET_UNITS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextPOLYGON_OFFSET_UNITS, (intptr_t)0 },
    { "POLYGON_OFFSET_FACTOR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextPOLYGON_OFFSET_FACTOR, (intptr_t)0 },
    { "TEXTURE_BINDING_2D", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_BINDING_2D, (intptr_t)0 },
    { "SAMPLE_BUFFERS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSAMPLE_BUFFERS, (intptr_t)0 },
    { "SAMPLES", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSAMPLES, (intptr_t)0 },
    { "SAMPLE_COVERAGE_VALUE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSAMPLE_COVERAGE_VALUE, (intptr_t)0 },
    { "SAMPLE_COVERAGE_INVERT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSAMPLE_COVERAGE_INVERT, (intptr_t)0 },
    { "NUM_COMPRESSED_TEXTURE_FORMATS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextNUM_COMPRESSED_TEXTURE_FORMATS, (intptr_t)0 },
    { "COMPRESSED_TEXTURE_FORMATS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCOMPRESSED_TEXTURE_FORMATS, (intptr_t)0 },
    { "DONT_CARE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDONT_CARE, (intptr_t)0 },
    { "FASTEST", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFASTEST, (intptr_t)0 },
    { "NICEST", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextNICEST, (intptr_t)0 },
    { "GENERATE_MIPMAP_HINT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextGENERATE_MIPMAP_HINT, (intptr_t)0 },
    { "BYTE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBYTE, (intptr_t)0 },
    { "UNSIGNED_BYTE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextUNSIGNED_BYTE, (intptr_t)0 },
    { "SHORT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSHORT, (intptr_t)0 },
    { "UNSIGNED_SHORT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextUNSIGNED_SHORT, (intptr_t)0 },
    { "INT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextINT, (intptr_t)0 },
    { "UNSIGNED_INT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextUNSIGNED_INT, (intptr_t)0 },
    { "FLOAT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFLOAT, (intptr_t)0 },
    { "FIXED", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFIXED, (intptr_t)0 },
    { "DEPTH_COMPONENT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDEPTH_COMPONENT, (intptr_t)0 },
    { "ALPHA", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextALPHA, (intptr_t)0 },
    { "RGB", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRGB, (intptr_t)0 },
    { "RGBA", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRGBA, (intptr_t)0 },
    { "LUMINANCE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLUMINANCE, (intptr_t)0 },
    { "LUMINANCE_ALPHA", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLUMINANCE_ALPHA, (intptr_t)0 },
    { "UNSIGNED_SHORT_4_4_4_4", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextUNSIGNED_SHORT_4_4_4_4, (intptr_t)0 },
    { "UNSIGNED_SHORT_5_5_5_1", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextUNSIGNED_SHORT_5_5_5_1, (intptr_t)0 },
    { "UNSIGNED_SHORT_5_6_5", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextUNSIGNED_SHORT_5_6_5, (intptr_t)0 },
    { "FRAGMENT_SHADER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRAGMENT_SHADER, (intptr_t)0 },
    { "VERTEX_SHADER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextVERTEX_SHADER, (intptr_t)0 },
    { "MAX_VERTEX_ATTRIBS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMAX_VERTEX_ATTRIBS, (intptr_t)0 },
    { "MAX_VERTEX_UNIFORM_VECTORS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMAX_VERTEX_UNIFORM_VECTORS, (intptr_t)0 },
    { "MAX_VARYING_VECTORS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMAX_VARYING_VECTORS, (intptr_t)0 },
    { "MAX_COMBINED_TEXTURE_IMAGE_UNITS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMAX_COMBINED_TEXTURE_IMAGE_UNITS, (intptr_t)0 },
    { "MAX_VERTEX_TEXTURE_IMAGE_UNITS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMAX_VERTEX_TEXTURE_IMAGE_UNITS, (intptr_t)0 },
    { "MAX_TEXTURE_IMAGE_UNITS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMAX_TEXTURE_IMAGE_UNITS, (intptr_t)0 },
    { "MAX_FRAGMENT_UNIFORM_VECTORS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMAX_FRAGMENT_UNIFORM_VECTORS, (intptr_t)0 },
    { "SHADER_TYPE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSHADER_TYPE, (intptr_t)0 },
    { "DELETE_STATUS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDELETE_STATUS, (intptr_t)0 },
    { "LINK_STATUS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLINK_STATUS, (intptr_t)0 },
    { "VALIDATE_STATUS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextVALIDATE_STATUS, (intptr_t)0 },
    { "ATTACHED_SHADERS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextATTACHED_SHADERS, (intptr_t)0 },
    { "ACTIVE_UNIFORMS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextACTIVE_UNIFORMS, (intptr_t)0 },
    { "ACTIVE_UNIFORM_MAX_LENGTH", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextACTIVE_UNIFORM_MAX_LENGTH, (intptr_t)0 },
    { "ACTIVE_ATTRIBUTES", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextACTIVE_ATTRIBUTES, (intptr_t)0 },
    { "ACTIVE_ATTRIBUTE_MAX_LENGTH", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextACTIVE_ATTRIBUTE_MAX_LENGTH, (intptr_t)0 },
    { "SHADING_LANGUAGE_VERSION", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSHADING_LANGUAGE_VERSION, (intptr_t)0 },
    { "CURRENT_PROGRAM", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCURRENT_PROGRAM, (intptr_t)0 },
    { "NEVER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextNEVER, (intptr_t)0 },
    { "LESS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLESS, (intptr_t)0 },
    { "EQUAL", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextEQUAL, (intptr_t)0 },
    { "LEQUAL", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLEQUAL, (intptr_t)0 },
    { "GREATER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextGREATER, (intptr_t)0 },
    { "NOTEQUAL", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextNOTEQUAL, (intptr_t)0 },
    { "GEQUAL", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextGEQUAL, (intptr_t)0 },
    { "ALWAYS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextALWAYS, (intptr_t)0 },
    { "KEEP", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextKEEP, (intptr_t)0 },
    { "REPLACE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextREPLACE, (intptr_t)0 },
    { "INCR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextINCR, (intptr_t)0 },
    { "DECR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDECR, (intptr_t)0 },
    { "INVERT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextINVERT, (intptr_t)0 },
    { "INCR_WRAP", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextINCR_WRAP, (intptr_t)0 },
    { "DECR_WRAP", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDECR_WRAP, (intptr_t)0 },
    { "VENDOR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextVENDOR, (intptr_t)0 },
    { "RENDERER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRENDERER, (intptr_t)0 },
    { "VERSION", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextVERSION, (intptr_t)0 },
    { "EXTENSIONS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextEXTENSIONS, (intptr_t)0 },
    { "NEAREST", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextNEAREST, (intptr_t)0 },
    { "LINEAR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLINEAR, (intptr_t)0 },
    { "NEAREST_MIPMAP_NEAREST", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextNEAREST_MIPMAP_NEAREST, (intptr_t)0 },
    { "LINEAR_MIPMAP_NEAREST", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLINEAR_MIPMAP_NEAREST, (intptr_t)0 },
    { "NEAREST_MIPMAP_LINEAR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextNEAREST_MIPMAP_LINEAR, (intptr_t)0 },
    { "LINEAR_MIPMAP_LINEAR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLINEAR_MIPMAP_LINEAR, (intptr_t)0 },
    { "TEXTURE_MAG_FILTER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_MAG_FILTER, (intptr_t)0 },
    { "TEXTURE_MIN_FILTER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_MIN_FILTER, (intptr_t)0 },
    { "TEXTURE_WRAP_S", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_WRAP_S, (intptr_t)0 },
    { "TEXTURE_WRAP_T", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_WRAP_T, (intptr_t)0 },
    { "TEXTURE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE, (intptr_t)0 },
    { "TEXTURE_CUBE_MAP", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_CUBE_MAP, (intptr_t)0 },
    { "TEXTURE_BINDING_CUBE_MAP", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_BINDING_CUBE_MAP, (intptr_t)0 },
    { "TEXTURE_CUBE_MAP_POSITIVE_X", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_CUBE_MAP_POSITIVE_X, (intptr_t)0 },
    { "TEXTURE_CUBE_MAP_NEGATIVE_X", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_CUBE_MAP_NEGATIVE_X, (intptr_t)0 },
    { "TEXTURE_CUBE_MAP_POSITIVE_Y", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_CUBE_MAP_POSITIVE_Y, (intptr_t)0 },
    { "TEXTURE_CUBE_MAP_NEGATIVE_Y", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_CUBE_MAP_NEGATIVE_Y, (intptr_t)0 },
    { "TEXTURE_CUBE_MAP_POSITIVE_Z", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_CUBE_MAP_POSITIVE_Z, (intptr_t)0 },
    { "TEXTURE_CUBE_MAP_NEGATIVE_Z", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_CUBE_MAP_NEGATIVE_Z, (intptr_t)0 },
    { "MAX_CUBE_MAP_TEXTURE_SIZE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMAX_CUBE_MAP_TEXTURE_SIZE, (intptr_t)0 },
    { "TEXTURE0", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE0, (intptr_t)0 },
    { "TEXTURE1", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE1, (intptr_t)0 },
    { "TEXTURE2", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE2, (intptr_t)0 },
    { "TEXTURE3", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE3, (intptr_t)0 },
    { "TEXTURE4", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE4, (intptr_t)0 },
    { "TEXTURE5", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE5, (intptr_t)0 },
    { "TEXTURE6", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE6, (intptr_t)0 },
    { "TEXTURE7", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE7, (intptr_t)0 },
    { "TEXTURE8", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE8, (intptr_t)0 },
    { "TEXTURE9", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE9, (intptr_t)0 },
    { "TEXTURE10", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE10, (intptr_t)0 },
    { "TEXTURE11", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE11, (intptr_t)0 },
    { "TEXTURE12", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE12, (intptr_t)0 },
    { "TEXTURE13", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE13, (intptr_t)0 },
    { "TEXTURE14", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE14, (intptr_t)0 },
    { "TEXTURE15", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE15, (intptr_t)0 },
    { "TEXTURE16", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE16, (intptr_t)0 },
    { "TEXTURE17", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE17, (intptr_t)0 },
    { "TEXTURE18", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE18, (intptr_t)0 },
    { "TEXTURE19", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE19, (intptr_t)0 },
    { "TEXTURE20", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE20, (intptr_t)0 },
    { "TEXTURE21", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE21, (intptr_t)0 },
    { "TEXTURE22", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE22, (intptr_t)0 },
    { "TEXTURE23", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE23, (intptr_t)0 },
    { "TEXTURE24", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE24, (intptr_t)0 },
    { "TEXTURE25", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE25, (intptr_t)0 },
    { "TEXTURE26", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE26, (intptr_t)0 },
    { "TEXTURE27", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE27, (intptr_t)0 },
    { "TEXTURE28", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE28, (intptr_t)0 },
    { "TEXTURE29", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE29, (intptr_t)0 },
    { "TEXTURE30", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE30, (intptr_t)0 },
    { "TEXTURE31", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE31, (intptr_t)0 },
    { "ACTIVE_TEXTURE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextACTIVE_TEXTURE, (intptr_t)0 },
    { "REPEAT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextREPEAT, (intptr_t)0 },
    { "CLAMP_TO_EDGE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCLAMP_TO_EDGE, (intptr_t)0 },
    { "MIRRORED_REPEAT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMIRRORED_REPEAT, (intptr_t)0 },
    { "FLOAT_VEC2", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFLOAT_VEC2, (intptr_t)0 },
    { "FLOAT_VEC3", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFLOAT_VEC3, (intptr_t)0 },
    { "FLOAT_VEC4", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFLOAT_VEC4, (intptr_t)0 },
    { "INT_VEC2", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextINT_VEC2, (intptr_t)0 },
    { "INT_VEC3", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextINT_VEC3, (intptr_t)0 },
    { "INT_VEC4", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextINT_VEC4, (intptr_t)0 },
    { "BOOL", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBOOL, (intptr_t)0 },
    { "BOOL_VEC2", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBOOL_VEC2, (intptr_t)0 },
    { "BOOL_VEC3", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBOOL_VEC3, (intptr_t)0 },
    { "BOOL_VEC4", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBOOL_VEC4, (intptr_t)0 },
    { "FLOAT_MAT2", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFLOAT_MAT2, (intptr_t)0 },
    { "FLOAT_MAT3", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFLOAT_MAT3, (intptr_t)0 },
    { "FLOAT_MAT4", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFLOAT_MAT4, (intptr_t)0 },
    { "SAMPLER_2D", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSAMPLER_2D, (intptr_t)0 },
    { "SAMPLER_CUBE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSAMPLER_CUBE, (intptr_t)0 },
    { "VERTEX_ATTRIB_ARRAY_ENABLED", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextVERTEX_ATTRIB_ARRAY_ENABLED, (intptr_t)0 },
    { "VERTEX_ATTRIB_ARRAY_SIZE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextVERTEX_ATTRIB_ARRAY_SIZE, (intptr_t)0 },
    { "VERTEX_ATTRIB_ARRAY_STRIDE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextVERTEX_ATTRIB_ARRAY_STRIDE, (intptr_t)0 },
    { "VERTEX_ATTRIB_ARRAY_TYPE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextVERTEX_ATTRIB_ARRAY_TYPE, (intptr_t)0 },
    { "VERTEX_ATTRIB_ARRAY_NORMALIZED", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextVERTEX_ATTRIB_ARRAY_NORMALIZED, (intptr_t)0 },
    { "VERTEX_ATTRIB_ARRAY_POINTER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextVERTEX_ATTRIB_ARRAY_POINTER, (intptr_t)0 },
    { "VERTEX_ATTRIB_ARRAY_BUFFER_BINDING", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextVERTEX_ATTRIB_ARRAY_BUFFER_BINDING, (intptr_t)0 },
    { "IMPLEMENTATION_COLOR_READ_TYPE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextIMPLEMENTATION_COLOR_READ_TYPE, (intptr_t)0 },
    { "IMPLEMENTATION_COLOR_READ_FORMAT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextIMPLEMENTATION_COLOR_READ_FORMAT, (intptr_t)0 },
    { "COMPILE_STATUS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCOMPILE_STATUS, (intptr_t)0 },
    { "INFO_LOG_LENGTH", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextINFO_LOG_LENGTH, (intptr_t)0 },
    { "SHADER_SOURCE_LENGTH", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSHADER_SOURCE_LENGTH, (intptr_t)0 },
    { "SHADER_COMPILER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSHADER_COMPILER, (intptr_t)0 },
    { "SHADER_BINARY_FORMATS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSHADER_BINARY_FORMATS, (intptr_t)0 },
    { "NUM_SHADER_BINARY_FORMATS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextNUM_SHADER_BINARY_FORMATS, (intptr_t)0 },
    { "LOW_FLOAT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLOW_FLOAT, (intptr_t)0 },
    { "MEDIUM_FLOAT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMEDIUM_FLOAT, (intptr_t)0 },
    { "HIGH_FLOAT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextHIGH_FLOAT, (intptr_t)0 },
    { "LOW_INT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLOW_INT, (intptr_t)0 },
    { "MEDIUM_INT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMEDIUM_INT, (intptr_t)0 },
    { "HIGH_INT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextHIGH_INT, (intptr_t)0 },
    { "FRAMEBUFFER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRAMEBUFFER, (intptr_t)0 },
    { "RENDERBUFFER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRENDERBUFFER, (intptr_t)0 },
    { "RGBA4", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRGBA4, (intptr_t)0 },
    { "RGB5_A1", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRGB5_A1, (intptr_t)0 },
    { "RGB565", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRGB565, (intptr_t)0 },
    { "DEPTH_COMPONENT16", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDEPTH_COMPONENT16, (intptr_t)0 },
    { "STENCIL_INDEX", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_INDEX, (intptr_t)0 },
    { "STENCIL_INDEX8", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_INDEX8, (intptr_t)0 },
    { "RENDERBUFFER_WIDTH", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRENDERBUFFER_WIDTH, (intptr_t)0 },
    { "RENDERBUFFER_HEIGHT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRENDERBUFFER_HEIGHT, (intptr_t)0 },
    { "RENDERBUFFER_INTERNAL_FORMAT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRENDERBUFFER_INTERNAL_FORMAT, (intptr_t)0 },
    { "RENDERBUFFER_RED_SIZE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRENDERBUFFER_RED_SIZE, (intptr_t)0 },
    { "RENDERBUFFER_GREEN_SIZE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRENDERBUFFER_GREEN_SIZE, (intptr_t)0 },
    { "RENDERBUFFER_BLUE_SIZE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRENDERBUFFER_BLUE_SIZE, (intptr_t)0 },
    { "RENDERBUFFER_ALPHA_SIZE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRENDERBUFFER_ALPHA_SIZE, (intptr_t)0 },
    { "RENDERBUFFER_DEPTH_SIZE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRENDERBUFFER_DEPTH_SIZE, (intptr_t)0 },
    { "RENDERBUFFER_STENCIL_SIZE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRENDERBUFFER_STENCIL_SIZE, (intptr_t)0 },
    { "FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRAMEBUFFER_ATTACHMENT_OBJECT_TYPE, (intptr_t)0 },
    { "FRAMEBUFFER_ATTACHMENT_OBJECT_NAME", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRAMEBUFFER_ATTACHMENT_OBJECT_NAME, (intptr_t)0 },
    { "FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL, (intptr_t)0 },
    { "FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE, (intptr_t)0 },
    { "COLOR_ATTACHMENT0", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCOLOR_ATTACHMENT0, (intptr_t)0 },
    { "DEPTH_ATTACHMENT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDEPTH_ATTACHMENT, (intptr_t)0 },
    { "STENCIL_ATTACHMENT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_ATTACHMENT, (intptr_t)0 },
    { "NONE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextNONE, (intptr_t)0 },
    { "FRAMEBUFFER_COMPLETE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRAMEBUFFER_COMPLETE, (intptr_t)0 },
    { "FRAMEBUFFER_INCOMPLETE_ATTACHMENT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRAMEBUFFER_INCOMPLETE_ATTACHMENT, (intptr_t)0 },
    { "FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT, (intptr_t)0 },
    { "FRAMEBUFFER_INCOMPLETE_DIMENSIONS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRAMEBUFFER_INCOMPLETE_DIMENSIONS, (intptr_t)0 },
    { "FRAMEBUFFER_UNSUPPORTED", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRAMEBUFFER_UNSUPPORTED, (intptr_t)0 },
    { "FRAMEBUFFER_BINDING", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRAMEBUFFER_BINDING, (intptr_t)0 },
    { "RENDERBUFFER_BINDING", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRENDERBUFFER_BINDING, (intptr_t)0 },
    { "MAX_RENDERBUFFER_SIZE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMAX_RENDERBUFFER_SIZE, (intptr_t)0 },
    { "INVALID_FRAMEBUFFER_OPERATION", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextINVALID_FRAMEBUFFER_OPERATION, (intptr_t)0 },
    { 0, 0, 0, 0 }
};

static JSC_CONST_HASHTABLE HashTable JSWebGLRenderingContextConstructorTable =
#if ENABLE(PERFECT_HASH_SIZE)
    { 32767, JSWebGLRenderingContextConstructorTableValues, 0 };
#else
    { 1063, 1023, JSWebGLRenderingContextConstructorTableValues, 0 };
#endif

class JSWebGLRenderingContextConstructor : public DOMConstructorObject {
public:
    JSWebGLRenderingContextConstructor(ExecState* exec, JSDOMGlobalObject* globalObject)
        : DOMConstructorObject(JSWebGLRenderingContextConstructor::createStructure(globalObject->objectPrototype()), globalObject)
    {
        putDirect(exec->propertyNames().prototype, JSWebGLRenderingContextPrototype::self(exec, globalObject), None);
    }
    virtual bool getOwnPropertySlot(ExecState*, const Identifier&, PropertySlot&);
    virtual bool getOwnPropertyDescriptor(ExecState*, const Identifier&, PropertyDescriptor&);
    virtual const ClassInfo* classInfo() const { return &s_info; }
    static const ClassInfo s_info;

    static PassRefPtr<Structure> createStructure(JSValue proto) 
    { 
        return Structure::create(proto, TypeInfo(ObjectType, StructureFlags), AnonymousSlotCount); 
    }
    
protected:
    static const unsigned StructureFlags = OverridesGetOwnPropertySlot | ImplementsHasInstance | DOMConstructorObject::StructureFlags;
};

const ClassInfo JSWebGLRenderingContextConstructor::s_info = { "WebGLRenderingContextConstructor", 0, &JSWebGLRenderingContextConstructorTable, 0 };

bool JSWebGLRenderingContextConstructor::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSWebGLRenderingContextConstructor, DOMObject>(exec, &JSWebGLRenderingContextConstructorTable, this, propertyName, slot);
}

bool JSWebGLRenderingContextConstructor::getOwnPropertyDescriptor(ExecState* exec, const Identifier& propertyName, PropertyDescriptor& descriptor)
{
    return getStaticValueDescriptor<JSWebGLRenderingContextConstructor, DOMObject>(exec, &JSWebGLRenderingContextConstructorTable, this, propertyName, descriptor);
}

/* Hash table for prototype */

static const HashTableValue JSWebGLRenderingContextPrototypeTableValues[435] =
{
    { "DEPTH_BUFFER_BIT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDEPTH_BUFFER_BIT, (intptr_t)0 },
    { "STENCIL_BUFFER_BIT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_BUFFER_BIT, (intptr_t)0 },
    { "COLOR_BUFFER_BIT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCOLOR_BUFFER_BIT, (intptr_t)0 },
    { "FALSE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFALSE, (intptr_t)0 },
    { "TRUE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTRUE, (intptr_t)0 },
    { "POINTS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextPOINTS, (intptr_t)0 },
    { "LINES", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLINES, (intptr_t)0 },
    { "LINE_LOOP", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLINE_LOOP, (intptr_t)0 },
    { "LINE_STRIP", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLINE_STRIP, (intptr_t)0 },
    { "TRIANGLES", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTRIANGLES, (intptr_t)0 },
    { "TRIANGLE_STRIP", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTRIANGLE_STRIP, (intptr_t)0 },
    { "TRIANGLE_FAN", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTRIANGLE_FAN, (intptr_t)0 },
    { "ZERO", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextZERO, (intptr_t)0 },
    { "ONE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextONE, (intptr_t)0 },
    { "SRC_COLOR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSRC_COLOR, (intptr_t)0 },
    { "ONE_MINUS_SRC_COLOR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextONE_MINUS_SRC_COLOR, (intptr_t)0 },
    { "SRC_ALPHA", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSRC_ALPHA, (intptr_t)0 },
    { "ONE_MINUS_SRC_ALPHA", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextONE_MINUS_SRC_ALPHA, (intptr_t)0 },
    { "DST_ALPHA", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDST_ALPHA, (intptr_t)0 },
    { "ONE_MINUS_DST_ALPHA", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextONE_MINUS_DST_ALPHA, (intptr_t)0 },
    { "DST_COLOR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDST_COLOR, (intptr_t)0 },
    { "ONE_MINUS_DST_COLOR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextONE_MINUS_DST_COLOR, (intptr_t)0 },
    { "SRC_ALPHA_SATURATE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSRC_ALPHA_SATURATE, (intptr_t)0 },
    { "FUNC_ADD", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFUNC_ADD, (intptr_t)0 },
    { "BLEND_EQUATION", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBLEND_EQUATION, (intptr_t)0 },
    { "BLEND_EQUATION_RGB", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBLEND_EQUATION_RGB, (intptr_t)0 },
    { "BLEND_EQUATION_ALPHA", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBLEND_EQUATION_ALPHA, (intptr_t)0 },
    { "FUNC_SUBTRACT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFUNC_SUBTRACT, (intptr_t)0 },
    { "FUNC_REVERSE_SUBTRACT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFUNC_REVERSE_SUBTRACT, (intptr_t)0 },
    { "BLEND_DST_RGB", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBLEND_DST_RGB, (intptr_t)0 },
    { "BLEND_SRC_RGB", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBLEND_SRC_RGB, (intptr_t)0 },
    { "BLEND_DST_ALPHA", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBLEND_DST_ALPHA, (intptr_t)0 },
    { "BLEND_SRC_ALPHA", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBLEND_SRC_ALPHA, (intptr_t)0 },
    { "CONSTANT_COLOR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCONSTANT_COLOR, (intptr_t)0 },
    { "ONE_MINUS_CONSTANT_COLOR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextONE_MINUS_CONSTANT_COLOR, (intptr_t)0 },
    { "CONSTANT_ALPHA", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCONSTANT_ALPHA, (intptr_t)0 },
    { "ONE_MINUS_CONSTANT_ALPHA", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextONE_MINUS_CONSTANT_ALPHA, (intptr_t)0 },
    { "BLEND_COLOR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBLEND_COLOR, (intptr_t)0 },
    { "ARRAY_BUFFER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextARRAY_BUFFER, (intptr_t)0 },
    { "ELEMENT_ARRAY_BUFFER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextELEMENT_ARRAY_BUFFER, (intptr_t)0 },
    { "ARRAY_BUFFER_BINDING", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextARRAY_BUFFER_BINDING, (intptr_t)0 },
    { "ELEMENT_ARRAY_BUFFER_BINDING", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextELEMENT_ARRAY_BUFFER_BINDING, (intptr_t)0 },
    { "STREAM_DRAW", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTREAM_DRAW, (intptr_t)0 },
    { "STATIC_DRAW", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTATIC_DRAW, (intptr_t)0 },
    { "DYNAMIC_DRAW", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDYNAMIC_DRAW, (intptr_t)0 },
    { "BUFFER_SIZE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBUFFER_SIZE, (intptr_t)0 },
    { "BUFFER_USAGE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBUFFER_USAGE, (intptr_t)0 },
    { "CURRENT_VERTEX_ATTRIB", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCURRENT_VERTEX_ATTRIB, (intptr_t)0 },
    { "FRONT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRONT, (intptr_t)0 },
    { "BACK", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBACK, (intptr_t)0 },
    { "FRONT_AND_BACK", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRONT_AND_BACK, (intptr_t)0 },
    { "TEXTURE_2D", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_2D, (intptr_t)0 },
    { "CULL_FACE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCULL_FACE, (intptr_t)0 },
    { "BLEND", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBLEND, (intptr_t)0 },
    { "DITHER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDITHER, (intptr_t)0 },
    { "STENCIL_TEST", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_TEST, (intptr_t)0 },
    { "DEPTH_TEST", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDEPTH_TEST, (intptr_t)0 },
    { "SCISSOR_TEST", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSCISSOR_TEST, (intptr_t)0 },
    { "POLYGON_OFFSET_FILL", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextPOLYGON_OFFSET_FILL, (intptr_t)0 },
    { "SAMPLE_ALPHA_TO_COVERAGE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSAMPLE_ALPHA_TO_COVERAGE, (intptr_t)0 },
    { "SAMPLE_COVERAGE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSAMPLE_COVERAGE, (intptr_t)0 },
    { "NO_ERROR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextNO_ERROR, (intptr_t)0 },
    { "INVALID_ENUM", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextINVALID_ENUM, (intptr_t)0 },
    { "INVALID_VALUE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextINVALID_VALUE, (intptr_t)0 },
    { "INVALID_OPERATION", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextINVALID_OPERATION, (intptr_t)0 },
    { "OUT_OF_MEMORY", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextOUT_OF_MEMORY, (intptr_t)0 },
    { "CW", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCW, (intptr_t)0 },
    { "CCW", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCCW, (intptr_t)0 },
    { "LINE_WIDTH", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLINE_WIDTH, (intptr_t)0 },
    { "ALIASED_POINT_SIZE_RANGE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextALIASED_POINT_SIZE_RANGE, (intptr_t)0 },
    { "ALIASED_LINE_WIDTH_RANGE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextALIASED_LINE_WIDTH_RANGE, (intptr_t)0 },
    { "CULL_FACE_MODE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCULL_FACE_MODE, (intptr_t)0 },
    { "FRONT_FACE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRONT_FACE, (intptr_t)0 },
    { "DEPTH_RANGE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDEPTH_RANGE, (intptr_t)0 },
    { "DEPTH_WRITEMASK", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDEPTH_WRITEMASK, (intptr_t)0 },
    { "DEPTH_CLEAR_VALUE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDEPTH_CLEAR_VALUE, (intptr_t)0 },
    { "DEPTH_FUNC", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDEPTH_FUNC, (intptr_t)0 },
    { "STENCIL_CLEAR_VALUE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_CLEAR_VALUE, (intptr_t)0 },
    { "STENCIL_FUNC", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_FUNC, (intptr_t)0 },
    { "STENCIL_FAIL", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_FAIL, (intptr_t)0 },
    { "STENCIL_PASS_DEPTH_FAIL", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_PASS_DEPTH_FAIL, (intptr_t)0 },
    { "STENCIL_PASS_DEPTH_PASS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_PASS_DEPTH_PASS, (intptr_t)0 },
    { "STENCIL_REF", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_REF, (intptr_t)0 },
    { "STENCIL_VALUE_MASK", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_VALUE_MASK, (intptr_t)0 },
    { "STENCIL_WRITEMASK", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_WRITEMASK, (intptr_t)0 },
    { "STENCIL_BACK_FUNC", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_BACK_FUNC, (intptr_t)0 },
    { "STENCIL_BACK_FAIL", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_BACK_FAIL, (intptr_t)0 },
    { "STENCIL_BACK_PASS_DEPTH_FAIL", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_BACK_PASS_DEPTH_FAIL, (intptr_t)0 },
    { "STENCIL_BACK_PASS_DEPTH_PASS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_BACK_PASS_DEPTH_PASS, (intptr_t)0 },
    { "STENCIL_BACK_REF", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_BACK_REF, (intptr_t)0 },
    { "STENCIL_BACK_VALUE_MASK", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_BACK_VALUE_MASK, (intptr_t)0 },
    { "STENCIL_BACK_WRITEMASK", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_BACK_WRITEMASK, (intptr_t)0 },
    { "VIEWPORT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextVIEWPORT, (intptr_t)0 },
    { "SCISSOR_BOX", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSCISSOR_BOX, (intptr_t)0 },
    { "COLOR_CLEAR_VALUE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCOLOR_CLEAR_VALUE, (intptr_t)0 },
    { "COLOR_WRITEMASK", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCOLOR_WRITEMASK, (intptr_t)0 },
    { "UNPACK_ALIGNMENT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextUNPACK_ALIGNMENT, (intptr_t)0 },
    { "PACK_ALIGNMENT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextPACK_ALIGNMENT, (intptr_t)0 },
    { "MAX_TEXTURE_SIZE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMAX_TEXTURE_SIZE, (intptr_t)0 },
    { "MAX_VIEWPORT_DIMS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMAX_VIEWPORT_DIMS, (intptr_t)0 },
    { "SUBPIXEL_BITS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSUBPIXEL_BITS, (intptr_t)0 },
    { "RED_BITS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRED_BITS, (intptr_t)0 },
    { "GREEN_BITS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextGREEN_BITS, (intptr_t)0 },
    { "BLUE_BITS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBLUE_BITS, (intptr_t)0 },
    { "ALPHA_BITS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextALPHA_BITS, (intptr_t)0 },
    { "DEPTH_BITS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDEPTH_BITS, (intptr_t)0 },
    { "STENCIL_BITS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_BITS, (intptr_t)0 },
    { "POLYGON_OFFSET_UNITS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextPOLYGON_OFFSET_UNITS, (intptr_t)0 },
    { "POLYGON_OFFSET_FACTOR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextPOLYGON_OFFSET_FACTOR, (intptr_t)0 },
    { "TEXTURE_BINDING_2D", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_BINDING_2D, (intptr_t)0 },
    { "SAMPLE_BUFFERS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSAMPLE_BUFFERS, (intptr_t)0 },
    { "SAMPLES", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSAMPLES, (intptr_t)0 },
    { "SAMPLE_COVERAGE_VALUE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSAMPLE_COVERAGE_VALUE, (intptr_t)0 },
    { "SAMPLE_COVERAGE_INVERT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSAMPLE_COVERAGE_INVERT, (intptr_t)0 },
    { "NUM_COMPRESSED_TEXTURE_FORMATS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextNUM_COMPRESSED_TEXTURE_FORMATS, (intptr_t)0 },
    { "COMPRESSED_TEXTURE_FORMATS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCOMPRESSED_TEXTURE_FORMATS, (intptr_t)0 },
    { "DONT_CARE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDONT_CARE, (intptr_t)0 },
    { "FASTEST", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFASTEST, (intptr_t)0 },
    { "NICEST", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextNICEST, (intptr_t)0 },
    { "GENERATE_MIPMAP_HINT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextGENERATE_MIPMAP_HINT, (intptr_t)0 },
    { "BYTE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBYTE, (intptr_t)0 },
    { "UNSIGNED_BYTE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextUNSIGNED_BYTE, (intptr_t)0 },
    { "SHORT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSHORT, (intptr_t)0 },
    { "UNSIGNED_SHORT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextUNSIGNED_SHORT, (intptr_t)0 },
    { "INT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextINT, (intptr_t)0 },
    { "UNSIGNED_INT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextUNSIGNED_INT, (intptr_t)0 },
    { "FLOAT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFLOAT, (intptr_t)0 },
    { "FIXED", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFIXED, (intptr_t)0 },
    { "DEPTH_COMPONENT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDEPTH_COMPONENT, (intptr_t)0 },
    { "ALPHA", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextALPHA, (intptr_t)0 },
    { "RGB", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRGB, (intptr_t)0 },
    { "RGBA", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRGBA, (intptr_t)0 },
    { "LUMINANCE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLUMINANCE, (intptr_t)0 },
    { "LUMINANCE_ALPHA", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLUMINANCE_ALPHA, (intptr_t)0 },
    { "UNSIGNED_SHORT_4_4_4_4", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextUNSIGNED_SHORT_4_4_4_4, (intptr_t)0 },
    { "UNSIGNED_SHORT_5_5_5_1", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextUNSIGNED_SHORT_5_5_5_1, (intptr_t)0 },
    { "UNSIGNED_SHORT_5_6_5", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextUNSIGNED_SHORT_5_6_5, (intptr_t)0 },
    { "FRAGMENT_SHADER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRAGMENT_SHADER, (intptr_t)0 },
    { "VERTEX_SHADER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextVERTEX_SHADER, (intptr_t)0 },
    { "MAX_VERTEX_ATTRIBS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMAX_VERTEX_ATTRIBS, (intptr_t)0 },
    { "MAX_VERTEX_UNIFORM_VECTORS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMAX_VERTEX_UNIFORM_VECTORS, (intptr_t)0 },
    { "MAX_VARYING_VECTORS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMAX_VARYING_VECTORS, (intptr_t)0 },
    { "MAX_COMBINED_TEXTURE_IMAGE_UNITS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMAX_COMBINED_TEXTURE_IMAGE_UNITS, (intptr_t)0 },
    { "MAX_VERTEX_TEXTURE_IMAGE_UNITS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMAX_VERTEX_TEXTURE_IMAGE_UNITS, (intptr_t)0 },
    { "MAX_TEXTURE_IMAGE_UNITS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMAX_TEXTURE_IMAGE_UNITS, (intptr_t)0 },
    { "MAX_FRAGMENT_UNIFORM_VECTORS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMAX_FRAGMENT_UNIFORM_VECTORS, (intptr_t)0 },
    { "SHADER_TYPE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSHADER_TYPE, (intptr_t)0 },
    { "DELETE_STATUS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDELETE_STATUS, (intptr_t)0 },
    { "LINK_STATUS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLINK_STATUS, (intptr_t)0 },
    { "VALIDATE_STATUS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextVALIDATE_STATUS, (intptr_t)0 },
    { "ATTACHED_SHADERS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextATTACHED_SHADERS, (intptr_t)0 },
    { "ACTIVE_UNIFORMS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextACTIVE_UNIFORMS, (intptr_t)0 },
    { "ACTIVE_UNIFORM_MAX_LENGTH", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextACTIVE_UNIFORM_MAX_LENGTH, (intptr_t)0 },
    { "ACTIVE_ATTRIBUTES", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextACTIVE_ATTRIBUTES, (intptr_t)0 },
    { "ACTIVE_ATTRIBUTE_MAX_LENGTH", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextACTIVE_ATTRIBUTE_MAX_LENGTH, (intptr_t)0 },
    { "SHADING_LANGUAGE_VERSION", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSHADING_LANGUAGE_VERSION, (intptr_t)0 },
    { "CURRENT_PROGRAM", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCURRENT_PROGRAM, (intptr_t)0 },
    { "NEVER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextNEVER, (intptr_t)0 },
    { "LESS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLESS, (intptr_t)0 },
    { "EQUAL", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextEQUAL, (intptr_t)0 },
    { "LEQUAL", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLEQUAL, (intptr_t)0 },
    { "GREATER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextGREATER, (intptr_t)0 },
    { "NOTEQUAL", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextNOTEQUAL, (intptr_t)0 },
    { "GEQUAL", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextGEQUAL, (intptr_t)0 },
    { "ALWAYS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextALWAYS, (intptr_t)0 },
    { "KEEP", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextKEEP, (intptr_t)0 },
    { "REPLACE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextREPLACE, (intptr_t)0 },
    { "INCR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextINCR, (intptr_t)0 },
    { "DECR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDECR, (intptr_t)0 },
    { "INVERT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextINVERT, (intptr_t)0 },
    { "INCR_WRAP", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextINCR_WRAP, (intptr_t)0 },
    { "DECR_WRAP", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDECR_WRAP, (intptr_t)0 },
    { "VENDOR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextVENDOR, (intptr_t)0 },
    { "RENDERER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRENDERER, (intptr_t)0 },
    { "VERSION", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextVERSION, (intptr_t)0 },
    { "EXTENSIONS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextEXTENSIONS, (intptr_t)0 },
    { "NEAREST", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextNEAREST, (intptr_t)0 },
    { "LINEAR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLINEAR, (intptr_t)0 },
    { "NEAREST_MIPMAP_NEAREST", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextNEAREST_MIPMAP_NEAREST, (intptr_t)0 },
    { "LINEAR_MIPMAP_NEAREST", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLINEAR_MIPMAP_NEAREST, (intptr_t)0 },
    { "NEAREST_MIPMAP_LINEAR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextNEAREST_MIPMAP_LINEAR, (intptr_t)0 },
    { "LINEAR_MIPMAP_LINEAR", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLINEAR_MIPMAP_LINEAR, (intptr_t)0 },
    { "TEXTURE_MAG_FILTER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_MAG_FILTER, (intptr_t)0 },
    { "TEXTURE_MIN_FILTER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_MIN_FILTER, (intptr_t)0 },
    { "TEXTURE_WRAP_S", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_WRAP_S, (intptr_t)0 },
    { "TEXTURE_WRAP_T", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_WRAP_T, (intptr_t)0 },
    { "TEXTURE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE, (intptr_t)0 },
    { "TEXTURE_CUBE_MAP", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_CUBE_MAP, (intptr_t)0 },
    { "TEXTURE_BINDING_CUBE_MAP", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_BINDING_CUBE_MAP, (intptr_t)0 },
    { "TEXTURE_CUBE_MAP_POSITIVE_X", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_CUBE_MAP_POSITIVE_X, (intptr_t)0 },
    { "TEXTURE_CUBE_MAP_NEGATIVE_X", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_CUBE_MAP_NEGATIVE_X, (intptr_t)0 },
    { "TEXTURE_CUBE_MAP_POSITIVE_Y", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_CUBE_MAP_POSITIVE_Y, (intptr_t)0 },
    { "TEXTURE_CUBE_MAP_NEGATIVE_Y", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_CUBE_MAP_NEGATIVE_Y, (intptr_t)0 },
    { "TEXTURE_CUBE_MAP_POSITIVE_Z", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_CUBE_MAP_POSITIVE_Z, (intptr_t)0 },
    { "TEXTURE_CUBE_MAP_NEGATIVE_Z", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE_CUBE_MAP_NEGATIVE_Z, (intptr_t)0 },
    { "MAX_CUBE_MAP_TEXTURE_SIZE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMAX_CUBE_MAP_TEXTURE_SIZE, (intptr_t)0 },
    { "TEXTURE0", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE0, (intptr_t)0 },
    { "TEXTURE1", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE1, (intptr_t)0 },
    { "TEXTURE2", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE2, (intptr_t)0 },
    { "TEXTURE3", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE3, (intptr_t)0 },
    { "TEXTURE4", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE4, (intptr_t)0 },
    { "TEXTURE5", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE5, (intptr_t)0 },
    { "TEXTURE6", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE6, (intptr_t)0 },
    { "TEXTURE7", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE7, (intptr_t)0 },
    { "TEXTURE8", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE8, (intptr_t)0 },
    { "TEXTURE9", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE9, (intptr_t)0 },
    { "TEXTURE10", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE10, (intptr_t)0 },
    { "TEXTURE11", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE11, (intptr_t)0 },
    { "TEXTURE12", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE12, (intptr_t)0 },
    { "TEXTURE13", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE13, (intptr_t)0 },
    { "TEXTURE14", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE14, (intptr_t)0 },
    { "TEXTURE15", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE15, (intptr_t)0 },
    { "TEXTURE16", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE16, (intptr_t)0 },
    { "TEXTURE17", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE17, (intptr_t)0 },
    { "TEXTURE18", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE18, (intptr_t)0 },
    { "TEXTURE19", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE19, (intptr_t)0 },
    { "TEXTURE20", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE20, (intptr_t)0 },
    { "TEXTURE21", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE21, (intptr_t)0 },
    { "TEXTURE22", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE22, (intptr_t)0 },
    { "TEXTURE23", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE23, (intptr_t)0 },
    { "TEXTURE24", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE24, (intptr_t)0 },
    { "TEXTURE25", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE25, (intptr_t)0 },
    { "TEXTURE26", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE26, (intptr_t)0 },
    { "TEXTURE27", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE27, (intptr_t)0 },
    { "TEXTURE28", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE28, (intptr_t)0 },
    { "TEXTURE29", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE29, (intptr_t)0 },
    { "TEXTURE30", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE30, (intptr_t)0 },
    { "TEXTURE31", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextTEXTURE31, (intptr_t)0 },
    { "ACTIVE_TEXTURE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextACTIVE_TEXTURE, (intptr_t)0 },
    { "REPEAT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextREPEAT, (intptr_t)0 },
    { "CLAMP_TO_EDGE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCLAMP_TO_EDGE, (intptr_t)0 },
    { "MIRRORED_REPEAT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMIRRORED_REPEAT, (intptr_t)0 },
    { "FLOAT_VEC2", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFLOAT_VEC2, (intptr_t)0 },
    { "FLOAT_VEC3", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFLOAT_VEC3, (intptr_t)0 },
    { "FLOAT_VEC4", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFLOAT_VEC4, (intptr_t)0 },
    { "INT_VEC2", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextINT_VEC2, (intptr_t)0 },
    { "INT_VEC3", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextINT_VEC3, (intptr_t)0 },
    { "INT_VEC4", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextINT_VEC4, (intptr_t)0 },
    { "BOOL", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBOOL, (intptr_t)0 },
    { "BOOL_VEC2", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBOOL_VEC2, (intptr_t)0 },
    { "BOOL_VEC3", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBOOL_VEC3, (intptr_t)0 },
    { "BOOL_VEC4", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextBOOL_VEC4, (intptr_t)0 },
    { "FLOAT_MAT2", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFLOAT_MAT2, (intptr_t)0 },
    { "FLOAT_MAT3", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFLOAT_MAT3, (intptr_t)0 },
    { "FLOAT_MAT4", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFLOAT_MAT4, (intptr_t)0 },
    { "SAMPLER_2D", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSAMPLER_2D, (intptr_t)0 },
    { "SAMPLER_CUBE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSAMPLER_CUBE, (intptr_t)0 },
    { "VERTEX_ATTRIB_ARRAY_ENABLED", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextVERTEX_ATTRIB_ARRAY_ENABLED, (intptr_t)0 },
    { "VERTEX_ATTRIB_ARRAY_SIZE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextVERTEX_ATTRIB_ARRAY_SIZE, (intptr_t)0 },
    { "VERTEX_ATTRIB_ARRAY_STRIDE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextVERTEX_ATTRIB_ARRAY_STRIDE, (intptr_t)0 },
    { "VERTEX_ATTRIB_ARRAY_TYPE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextVERTEX_ATTRIB_ARRAY_TYPE, (intptr_t)0 },
    { "VERTEX_ATTRIB_ARRAY_NORMALIZED", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextVERTEX_ATTRIB_ARRAY_NORMALIZED, (intptr_t)0 },
    { "VERTEX_ATTRIB_ARRAY_POINTER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextVERTEX_ATTRIB_ARRAY_POINTER, (intptr_t)0 },
    { "VERTEX_ATTRIB_ARRAY_BUFFER_BINDING", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextVERTEX_ATTRIB_ARRAY_BUFFER_BINDING, (intptr_t)0 },
    { "IMPLEMENTATION_COLOR_READ_TYPE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextIMPLEMENTATION_COLOR_READ_TYPE, (intptr_t)0 },
    { "IMPLEMENTATION_COLOR_READ_FORMAT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextIMPLEMENTATION_COLOR_READ_FORMAT, (intptr_t)0 },
    { "COMPILE_STATUS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCOMPILE_STATUS, (intptr_t)0 },
    { "INFO_LOG_LENGTH", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextINFO_LOG_LENGTH, (intptr_t)0 },
    { "SHADER_SOURCE_LENGTH", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSHADER_SOURCE_LENGTH, (intptr_t)0 },
    { "SHADER_COMPILER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSHADER_COMPILER, (intptr_t)0 },
    { "SHADER_BINARY_FORMATS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSHADER_BINARY_FORMATS, (intptr_t)0 },
    { "NUM_SHADER_BINARY_FORMATS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextNUM_SHADER_BINARY_FORMATS, (intptr_t)0 },
    { "LOW_FLOAT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLOW_FLOAT, (intptr_t)0 },
    { "MEDIUM_FLOAT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMEDIUM_FLOAT, (intptr_t)0 },
    { "HIGH_FLOAT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextHIGH_FLOAT, (intptr_t)0 },
    { "LOW_INT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextLOW_INT, (intptr_t)0 },
    { "MEDIUM_INT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMEDIUM_INT, (intptr_t)0 },
    { "HIGH_INT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextHIGH_INT, (intptr_t)0 },
    { "FRAMEBUFFER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRAMEBUFFER, (intptr_t)0 },
    { "RENDERBUFFER", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRENDERBUFFER, (intptr_t)0 },
    { "RGBA4", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRGBA4, (intptr_t)0 },
    { "RGB5_A1", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRGB5_A1, (intptr_t)0 },
    { "RGB565", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRGB565, (intptr_t)0 },
    { "DEPTH_COMPONENT16", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDEPTH_COMPONENT16, (intptr_t)0 },
    { "STENCIL_INDEX", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_INDEX, (intptr_t)0 },
    { "STENCIL_INDEX8", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_INDEX8, (intptr_t)0 },
    { "RENDERBUFFER_WIDTH", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRENDERBUFFER_WIDTH, (intptr_t)0 },
    { "RENDERBUFFER_HEIGHT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRENDERBUFFER_HEIGHT, (intptr_t)0 },
    { "RENDERBUFFER_INTERNAL_FORMAT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRENDERBUFFER_INTERNAL_FORMAT, (intptr_t)0 },
    { "RENDERBUFFER_RED_SIZE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRENDERBUFFER_RED_SIZE, (intptr_t)0 },
    { "RENDERBUFFER_GREEN_SIZE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRENDERBUFFER_GREEN_SIZE, (intptr_t)0 },
    { "RENDERBUFFER_BLUE_SIZE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRENDERBUFFER_BLUE_SIZE, (intptr_t)0 },
    { "RENDERBUFFER_ALPHA_SIZE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRENDERBUFFER_ALPHA_SIZE, (intptr_t)0 },
    { "RENDERBUFFER_DEPTH_SIZE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRENDERBUFFER_DEPTH_SIZE, (intptr_t)0 },
    { "RENDERBUFFER_STENCIL_SIZE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRENDERBUFFER_STENCIL_SIZE, (intptr_t)0 },
    { "FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRAMEBUFFER_ATTACHMENT_OBJECT_TYPE, (intptr_t)0 },
    { "FRAMEBUFFER_ATTACHMENT_OBJECT_NAME", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRAMEBUFFER_ATTACHMENT_OBJECT_NAME, (intptr_t)0 },
    { "FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL, (intptr_t)0 },
    { "FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE, (intptr_t)0 },
    { "COLOR_ATTACHMENT0", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextCOLOR_ATTACHMENT0, (intptr_t)0 },
    { "DEPTH_ATTACHMENT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextDEPTH_ATTACHMENT, (intptr_t)0 },
    { "STENCIL_ATTACHMENT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextSTENCIL_ATTACHMENT, (intptr_t)0 },
    { "NONE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextNONE, (intptr_t)0 },
    { "FRAMEBUFFER_COMPLETE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRAMEBUFFER_COMPLETE, (intptr_t)0 },
    { "FRAMEBUFFER_INCOMPLETE_ATTACHMENT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRAMEBUFFER_INCOMPLETE_ATTACHMENT, (intptr_t)0 },
    { "FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT, (intptr_t)0 },
    { "FRAMEBUFFER_INCOMPLETE_DIMENSIONS", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRAMEBUFFER_INCOMPLETE_DIMENSIONS, (intptr_t)0 },
    { "FRAMEBUFFER_UNSUPPORTED", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRAMEBUFFER_UNSUPPORTED, (intptr_t)0 },
    { "FRAMEBUFFER_BINDING", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextFRAMEBUFFER_BINDING, (intptr_t)0 },
    { "RENDERBUFFER_BINDING", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextRENDERBUFFER_BINDING, (intptr_t)0 },
    { "MAX_RENDERBUFFER_SIZE", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextMAX_RENDERBUFFER_SIZE, (intptr_t)0 },
    { "INVALID_FRAMEBUFFER_OPERATION", DontDelete|ReadOnly, (intptr_t)jsWebGLRenderingContextINVALID_FRAMEBUFFER_OPERATION, (intptr_t)0 },
    { "sizeInBytes", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionSizeInBytes, (intptr_t)1 },
    { "activeTexture", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionActiveTexture, (intptr_t)1 },
    { "attachShader", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionAttachShader, (intptr_t)2 },
    { "bindAttribLocation", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionBindAttribLocation, (intptr_t)3 },
    { "bindBuffer", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionBindBuffer, (intptr_t)2 },
    { "bindFramebuffer", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionBindFramebuffer, (intptr_t)2 },
    { "bindRenderbuffer", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionBindRenderbuffer, (intptr_t)2 },
    { "bindTexture", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionBindTexture, (intptr_t)2 },
    { "blendColor", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionBlendColor, (intptr_t)4 },
    { "blendEquation", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionBlendEquation, (intptr_t)1 },
    { "blendEquationSeparate", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionBlendEquationSeparate, (intptr_t)2 },
    { "blendFunc", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionBlendFunc, (intptr_t)2 },
    { "blendFuncSeparate", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionBlendFuncSeparate, (intptr_t)4 },
    { "bufferData", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionBufferData, (intptr_t)0 },
    { "bufferSubData", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionBufferSubData, (intptr_t)0 },
    { "checkFramebufferStatus", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionCheckFramebufferStatus, (intptr_t)1 },
    { "clear", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionClear, (intptr_t)1 },
    { "clearColor", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionClearColor, (intptr_t)4 },
    { "clearDepth", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionClearDepth, (intptr_t)1 },
    { "clearStencil", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionClearStencil, (intptr_t)1 },
    { "colorMask", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionColorMask, (intptr_t)4 },
    { "compileShader", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionCompileShader, (intptr_t)1 },
    { "copyTexImage2D", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionCopyTexImage2D, (intptr_t)8 },
    { "copyTexSubImage2D", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionCopyTexSubImage2D, (intptr_t)8 },
    { "createBuffer", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionCreateBuffer, (intptr_t)0 },
    { "createFramebuffer", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionCreateFramebuffer, (intptr_t)0 },
    { "createProgram", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionCreateProgram, (intptr_t)0 },
    { "createRenderbuffer", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionCreateRenderbuffer, (intptr_t)0 },
    { "createShader", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionCreateShader, (intptr_t)1 },
    { "createTexture", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionCreateTexture, (intptr_t)0 },
    { "cullFace", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionCullFace, (intptr_t)1 },
    { "deleteBuffer", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionDeleteBuffer, (intptr_t)1 },
    { "deleteFramebuffer", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionDeleteFramebuffer, (intptr_t)1 },
    { "deleteProgram", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionDeleteProgram, (intptr_t)1 },
    { "deleteRenderbuffer", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionDeleteRenderbuffer, (intptr_t)1 },
    { "deleteShader", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionDeleteShader, (intptr_t)1 },
    { "deleteTexture", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionDeleteTexture, (intptr_t)1 },
    { "depthFunc", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionDepthFunc, (intptr_t)1 },
    { "depthMask", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionDepthMask, (intptr_t)1 },
    { "depthRange", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionDepthRange, (intptr_t)2 },
    { "detachShader", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionDetachShader, (intptr_t)2 },
    { "disable", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionDisable, (intptr_t)1 },
    { "disableVertexAttribArray", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionDisableVertexAttribArray, (intptr_t)1 },
    { "drawArrays", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionDrawArrays, (intptr_t)3 },
    { "drawElements", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionDrawElements, (intptr_t)4 },
    { "enable", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionEnable, (intptr_t)1 },
    { "enableVertexAttribArray", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionEnableVertexAttribArray, (intptr_t)1 },
    { "finish", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionFinish, (intptr_t)0 },
    { "flush", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionFlush, (intptr_t)0 },
    { "framebufferRenderbuffer", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionFramebufferRenderbuffer, (intptr_t)4 },
    { "framebufferTexture2D", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionFramebufferTexture2D, (intptr_t)5 },
    { "frontFace", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionFrontFace, (intptr_t)1 },
    { "generateMipmap", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionGenerateMipmap, (intptr_t)1 },
    { "getActiveAttrib", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionGetActiveAttrib, (intptr_t)2 },
    { "getActiveUniform", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionGetActiveUniform, (intptr_t)2 },
    { "getAttribLocation", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionGetAttribLocation, (intptr_t)2 },
    { "getBufferParameter", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionGetBufferParameter, (intptr_t)0 },
    { "getContextAttributes", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionGetContextAttributes, (intptr_t)0 },
    { "getError", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionGetError, (intptr_t)0 },
    { "getFramebufferAttachmentParameter", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionGetFramebufferAttachmentParameter, (intptr_t)0 },
    { "getParameter", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionGetParameter, (intptr_t)0 },
    { "getProgramParameter", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionGetProgramParameter, (intptr_t)0 },
    { "getProgramInfoLog", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionGetProgramInfoLog, (intptr_t)1 },
    { "getRenderbufferParameter", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionGetRenderbufferParameter, (intptr_t)0 },
    { "getShaderParameter", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionGetShaderParameter, (intptr_t)0 },
    { "getShaderInfoLog", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionGetShaderInfoLog, (intptr_t)1 },
    { "getShaderSource", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionGetShaderSource, (intptr_t)1 },
    { "getString", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionGetString, (intptr_t)1 },
    { "getTexParameter", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionGetTexParameter, (intptr_t)0 },
    { "getUniform", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionGetUniform, (intptr_t)0 },
    { "getUniformLocation", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionGetUniformLocation, (intptr_t)2 },
    { "getVertexAttrib", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionGetVertexAttrib, (intptr_t)0 },
    { "getVertexAttribOffset", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionGetVertexAttribOffset, (intptr_t)2 },
    { "hint", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionHint, (intptr_t)2 },
    { "isBuffer", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionIsBuffer, (intptr_t)1 },
    { "isEnabled", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionIsEnabled, (intptr_t)1 },
    { "isFramebuffer", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionIsFramebuffer, (intptr_t)1 },
    { "isProgram", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionIsProgram, (intptr_t)1 },
    { "isRenderbuffer", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionIsRenderbuffer, (intptr_t)1 },
    { "isShader", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionIsShader, (intptr_t)1 },
    { "isTexture", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionIsTexture, (intptr_t)1 },
    { "lineWidth", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionLineWidth, (intptr_t)1 },
    { "linkProgram", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionLinkProgram, (intptr_t)1 },
    { "pixelStorei", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionPixelStorei, (intptr_t)2 },
    { "polygonOffset", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionPolygonOffset, (intptr_t)2 },
    { "readPixels", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionReadPixels, (intptr_t)6 },
    { "releaseShaderCompiler", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionReleaseShaderCompiler, (intptr_t)0 },
    { "renderbufferStorage", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionRenderbufferStorage, (intptr_t)4 },
    { "sampleCoverage", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionSampleCoverage, (intptr_t)2 },
    { "scissor", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionScissor, (intptr_t)4 },
    { "shaderSource", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionShaderSource, (intptr_t)2 },
    { "stencilFunc", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionStencilFunc, (intptr_t)3 },
    { "stencilFuncSeparate", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionStencilFuncSeparate, (intptr_t)4 },
    { "stencilMask", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionStencilMask, (intptr_t)1 },
    { "stencilMaskSeparate", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionStencilMaskSeparate, (intptr_t)2 },
    { "stencilOp", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionStencilOp, (intptr_t)3 },
    { "stencilOpSeparate", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionStencilOpSeparate, (intptr_t)4 },
    { "texParameterf", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionTexParameterf, (intptr_t)3 },
    { "texParameteri", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionTexParameteri, (intptr_t)3 },
    { "texImage2D", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionTexImage2D, (intptr_t)0 },
    { "texSubImage2D", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionTexSubImage2D, (intptr_t)0 },
    { "uniform1f", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionUniform1f, (intptr_t)2 },
    { "uniform1fv", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionUniform1fv, (intptr_t)2 },
    { "uniform1i", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionUniform1i, (intptr_t)2 },
    { "uniform1iv", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionUniform1iv, (intptr_t)2 },
    { "uniform2f", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionUniform2f, (intptr_t)3 },
    { "uniform2fv", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionUniform2fv, (intptr_t)2 },
    { "uniform2i", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionUniform2i, (intptr_t)3 },
    { "uniform2iv", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionUniform2iv, (intptr_t)2 },
    { "uniform3f", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionUniform3f, (intptr_t)4 },
    { "uniform3fv", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionUniform3fv, (intptr_t)2 },
    { "uniform3i", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionUniform3i, (intptr_t)4 },
    { "uniform3iv", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionUniform3iv, (intptr_t)2 },
    { "uniform4f", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionUniform4f, (intptr_t)5 },
    { "uniform4fv", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionUniform4fv, (intptr_t)2 },
    { "uniform4i", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionUniform4i, (intptr_t)5 },
    { "uniform4iv", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionUniform4iv, (intptr_t)2 },
    { "uniformMatrix2fv", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionUniformMatrix2fv, (intptr_t)3 },
    { "uniformMatrix3fv", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionUniformMatrix3fv, (intptr_t)3 },
    { "uniformMatrix4fv", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionUniformMatrix4fv, (intptr_t)3 },
    { "useProgram", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionUseProgram, (intptr_t)1 },
    { "validateProgram", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionValidateProgram, (intptr_t)1 },
    { "vertexAttrib1f", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionVertexAttrib1f, (intptr_t)2 },
    { "vertexAttrib1fv", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionVertexAttrib1fv, (intptr_t)2 },
    { "vertexAttrib2f", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionVertexAttrib2f, (intptr_t)3 },
    { "vertexAttrib2fv", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionVertexAttrib2fv, (intptr_t)2 },
    { "vertexAttrib3f", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionVertexAttrib3f, (intptr_t)4 },
    { "vertexAttrib3fv", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionVertexAttrib3fv, (intptr_t)2 },
    { "vertexAttrib4f", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionVertexAttrib4f, (intptr_t)5 },
    { "vertexAttrib4fv", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionVertexAttrib4fv, (intptr_t)2 },
    { "vertexAttribPointer", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionVertexAttribPointer, (intptr_t)6 },
    { "viewport", DontDelete|Function, (intptr_t)jsWebGLRenderingContextPrototypeFunctionViewport, (intptr_t)4 },
    { 0, 0, 0, 0 }
};

static JSC_CONST_HASHTABLE HashTable JSWebGLRenderingContextPrototypeTable =
#if ENABLE(PERFECT_HASH_SIZE)
    { 65535, JSWebGLRenderingContextPrototypeTableValues, 0 };
#else
    { 1102, 1023, JSWebGLRenderingContextPrototypeTableValues, 0 };
#endif

const ClassInfo JSWebGLRenderingContextPrototype::s_info = { "WebGLRenderingContextPrototype", 0, &JSWebGLRenderingContextPrototypeTable, 0 };

JSObject* JSWebGLRenderingContextPrototype::self(ExecState* exec, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSWebGLRenderingContext>(exec, globalObject);
}

bool JSWebGLRenderingContextPrototype::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticPropertySlot<JSWebGLRenderingContextPrototype, JSObject>(exec, &JSWebGLRenderingContextPrototypeTable, this, propertyName, slot);
}

bool JSWebGLRenderingContextPrototype::getOwnPropertyDescriptor(ExecState* exec, const Identifier& propertyName, PropertyDescriptor& descriptor)
{
    return getStaticPropertyDescriptor<JSWebGLRenderingContextPrototype, JSObject>(exec, &JSWebGLRenderingContextPrototypeTable, this, propertyName, descriptor);
}

const ClassInfo JSWebGLRenderingContext::s_info = { "WebGLRenderingContext", &JSCanvasRenderingContext::s_info, &JSWebGLRenderingContextTable, 0 };

JSWebGLRenderingContext::JSWebGLRenderingContext(NonNullPassRefPtr<Structure> structure, JSDOMGlobalObject* globalObject, PassRefPtr<WebGLRenderingContext> impl)
    : JSCanvasRenderingContext(structure, globalObject, impl)
{
}

JSObject* JSWebGLRenderingContext::createPrototype(ExecState* exec, JSGlobalObject* globalObject)
{
    return new (exec) JSWebGLRenderingContextPrototype(JSWebGLRenderingContextPrototype::createStructure(JSCanvasRenderingContextPrototype::self(exec, globalObject)));
}

bool JSWebGLRenderingContext::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSWebGLRenderingContext, Base>(exec, &JSWebGLRenderingContextTable, this, propertyName, slot);
}

bool JSWebGLRenderingContext::getOwnPropertyDescriptor(ExecState* exec, const Identifier& propertyName, PropertyDescriptor& descriptor)
{
    return getStaticValueDescriptor<JSWebGLRenderingContext, Base>(exec, &JSWebGLRenderingContextTable, this, propertyName, descriptor);
}

JSValue jsWebGLRenderingContextConstructor(ExecState* exec, const Identifier&, const PropertySlot& slot)
{
    JSWebGLRenderingContext* domObject = static_cast<JSWebGLRenderingContext*>(asObject(slot.slotBase()));
    return JSWebGLRenderingContext::getConstructor(exec, domObject->globalObject());
}
JSValue JSWebGLRenderingContext::getConstructor(ExecState* exec, JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSWebGLRenderingContextConstructor>(exec, static_cast<JSDOMGlobalObject*>(globalObject));
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionSizeInBytes(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    unsigned type = args.at(0).toInt32(exec);


    JSC::JSValue result = jsNumber(exec, imp->sizeInBytes(type, ec));
    setDOMException(exec, ec);
    return result;
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionActiveTexture(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    unsigned texture = args.at(0).toInt32(exec);

    imp->activeTexture(texture, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionAttachShader(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    WebGLProgram* program = toWebGLProgram(args.at(0));
    WebGLShader* shader = toWebGLShader(args.at(1));

    imp->attachShader(program, shader, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionBindAttribLocation(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    WebGLProgram* program = toWebGLProgram(args.at(0));
    unsigned index = args.at(1).toInt32(exec);
    const UString& name = args.at(2).toString(exec);

    imp->bindAttribLocation(program, index, name, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionBindBuffer(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    unsigned target = args.at(0).toInt32(exec);
    WebGLBuffer* buffer = toWebGLBuffer(args.at(1));

    imp->bindBuffer(target, buffer, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionBindFramebuffer(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    unsigned target = args.at(0).toInt32(exec);
    WebGLFramebuffer* framebuffer = toWebGLFramebuffer(args.at(1));

    imp->bindFramebuffer(target, framebuffer, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionBindRenderbuffer(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    unsigned target = args.at(0).toInt32(exec);
    WebGLRenderbuffer* renderbuffer = toWebGLRenderbuffer(args.at(1));

    imp->bindRenderbuffer(target, renderbuffer, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionBindTexture(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    unsigned target = args.at(0).toInt32(exec);
    WebGLTexture* texture = toWebGLTexture(args.at(1));

    imp->bindTexture(target, texture, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionBlendColor(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    double red = args.at(0).toNumber(exec);
    double green = args.at(1).toNumber(exec);
    double blue = args.at(2).toNumber(exec);
    double alpha = args.at(3).toNumber(exec);

    imp->blendColor(red, green, blue, alpha);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionBlendEquation(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned mode = args.at(0).toInt32(exec);

    imp->blendEquation(mode);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionBlendEquationSeparate(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned modeRGB = args.at(0).toInt32(exec);
    unsigned modeAlpha = args.at(1).toInt32(exec);

    imp->blendEquationSeparate(modeRGB, modeAlpha);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionBlendFunc(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned sfactor = args.at(0).toInt32(exec);
    unsigned dfactor = args.at(1).toInt32(exec);

    imp->blendFunc(sfactor, dfactor);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionBlendFuncSeparate(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned srcRGB = args.at(0).toInt32(exec);
    unsigned dstRGB = args.at(1).toInt32(exec);
    unsigned srcAlpha = args.at(2).toInt32(exec);
    unsigned dstAlpha = args.at(3).toInt32(exec);

    imp->blendFuncSeparate(srcRGB, dstRGB, srcAlpha, dstAlpha);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionBufferData(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->bufferData(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionBufferSubData(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->bufferSubData(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionCheckFramebufferStatus(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned target = args.at(0).toInt32(exec);


    JSC::JSValue result = jsNumber(exec, imp->checkFramebufferStatus(target));
    return result;
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionClear(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned mask = args.at(0).toInt32(exec);

    imp->clear(mask);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionClearColor(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    double red = args.at(0).toNumber(exec);
    double green = args.at(1).toNumber(exec);
    double blue = args.at(2).toNumber(exec);
    double alpha = args.at(3).toNumber(exec);

    imp->clearColor(red, green, blue, alpha);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionClearDepth(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    double depth = args.at(0).toNumber(exec);

    imp->clearDepth(depth);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionClearStencil(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    int s = args.at(0).toInt32(exec);

    imp->clearStencil(s);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionColorMask(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    bool red = args.at(0).toBoolean(exec);
    bool green = args.at(1).toBoolean(exec);
    bool blue = args.at(2).toBoolean(exec);
    bool alpha = args.at(3).toBoolean(exec);

    imp->colorMask(red, green, blue, alpha);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionCompileShader(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    WebGLShader* shader = toWebGLShader(args.at(0));

    imp->compileShader(shader, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionCopyTexImage2D(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned target = args.at(0).toInt32(exec);
    int level = args.at(1).toInt32(exec);
    unsigned internalformat = args.at(2).toInt32(exec);
    int x = args.at(3).toInt32(exec);
    int y = args.at(4).toInt32(exec);
    unsigned width = args.at(5).toInt32(exec);
    unsigned height = args.at(6).toInt32(exec);
    int border = args.at(7).toInt32(exec);

    imp->copyTexImage2D(target, level, internalformat, x, y, width, height, border);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionCopyTexSubImage2D(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned target = args.at(0).toInt32(exec);
    int level = args.at(1).toInt32(exec);
    int xoffset = args.at(2).toInt32(exec);
    int yoffset = args.at(3).toInt32(exec);
    int x = args.at(4).toInt32(exec);
    int y = args.at(5).toInt32(exec);
    unsigned width = args.at(6).toInt32(exec);
    unsigned height = args.at(7).toInt32(exec);

    imp->copyTexSubImage2D(target, level, xoffset, yoffset, x, y, width, height);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionCreateBuffer(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());


    JSC::JSValue result = toJS(exec, castedThisObj->globalObject(), WTF::getPtr(imp->createBuffer()));
    return result;
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionCreateFramebuffer(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());


    JSC::JSValue result = toJS(exec, castedThisObj->globalObject(), WTF::getPtr(imp->createFramebuffer()));
    return result;
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionCreateProgram(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());


    JSC::JSValue result = toJS(exec, castedThisObj->globalObject(), WTF::getPtr(imp->createProgram()));
    return result;
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionCreateRenderbuffer(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());


    JSC::JSValue result = toJS(exec, castedThisObj->globalObject(), WTF::getPtr(imp->createRenderbuffer()));
    return result;
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionCreateShader(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    unsigned type = args.at(0).toInt32(exec);


    JSC::JSValue result = toJS(exec, castedThisObj->globalObject(), WTF::getPtr(imp->createShader(type, ec)));
    setDOMException(exec, ec);
    return result;
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionCreateTexture(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());


    JSC::JSValue result = toJS(exec, castedThisObj->globalObject(), WTF::getPtr(imp->createTexture()));
    return result;
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionCullFace(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned mode = args.at(0).toInt32(exec);

    imp->cullFace(mode);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionDeleteBuffer(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    WebGLBuffer* buffer = toWebGLBuffer(args.at(0));

    imp->deleteBuffer(buffer);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionDeleteFramebuffer(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    WebGLFramebuffer* framebuffer = toWebGLFramebuffer(args.at(0));

    imp->deleteFramebuffer(framebuffer);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionDeleteProgram(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    WebGLProgram* program = toWebGLProgram(args.at(0));

    imp->deleteProgram(program);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionDeleteRenderbuffer(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    WebGLRenderbuffer* renderbuffer = toWebGLRenderbuffer(args.at(0));

    imp->deleteRenderbuffer(renderbuffer);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionDeleteShader(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    WebGLShader* shader = toWebGLShader(args.at(0));

    imp->deleteShader(shader);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionDeleteTexture(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    WebGLTexture* texture = toWebGLTexture(args.at(0));

    imp->deleteTexture(texture);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionDepthFunc(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned func = args.at(0).toInt32(exec);

    imp->depthFunc(func);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionDepthMask(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    bool flag = args.at(0).toBoolean(exec);

    imp->depthMask(flag);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionDepthRange(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    double zNear = args.at(0).toNumber(exec);
    double zFar = args.at(1).toNumber(exec);

    imp->depthRange(zNear, zFar);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionDetachShader(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    WebGLProgram* program = toWebGLProgram(args.at(0));
    WebGLShader* shader = toWebGLShader(args.at(1));

    imp->detachShader(program, shader, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionDisable(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned cap = args.at(0).toInt32(exec);

    imp->disable(cap);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionDisableVertexAttribArray(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    unsigned index = args.at(0).toInt32(exec);

    imp->disableVertexAttribArray(index, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionDrawArrays(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    unsigned mode = args.at(0).toInt32(exec);
    int first = args.at(1).toInt32(exec);
    unsigned count = args.at(2).toInt32(exec);

    imp->drawArrays(mode, first, count, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionDrawElements(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    unsigned mode = args.at(0).toInt32(exec);
    int count = args.at(1).toInt32(exec);
    unsigned type = args.at(2).toInt32(exec);
    unsigned offset = args.at(3).toInt32(exec);

    imp->drawElements(mode, count, type, offset, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionEnable(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned cap = args.at(0).toInt32(exec);

    imp->enable(cap);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionEnableVertexAttribArray(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    unsigned index = args.at(0).toInt32(exec);

    imp->enableVertexAttribArray(index, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionFinish(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());

    imp->finish();
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionFlush(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());

    imp->flush();
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionFramebufferRenderbuffer(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    unsigned target = args.at(0).toInt32(exec);
    unsigned attachment = args.at(1).toInt32(exec);
    unsigned renderbuffertarget = args.at(2).toInt32(exec);
    WebGLRenderbuffer* renderbuffer = toWebGLRenderbuffer(args.at(3));

    imp->framebufferRenderbuffer(target, attachment, renderbuffertarget, renderbuffer, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionFramebufferTexture2D(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    unsigned target = args.at(0).toInt32(exec);
    unsigned attachment = args.at(1).toInt32(exec);
    unsigned textarget = args.at(2).toInt32(exec);
    WebGLTexture* texture = toWebGLTexture(args.at(3));
    int level = args.at(4).toInt32(exec);

    imp->framebufferTexture2D(target, attachment, textarget, texture, level, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionFrontFace(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned mode = args.at(0).toInt32(exec);

    imp->frontFace(mode);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionGenerateMipmap(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned target = args.at(0).toInt32(exec);

    imp->generateMipmap(target);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionGetActiveAttrib(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    WebGLProgram* program = toWebGLProgram(args.at(0));
    unsigned index = args.at(1).toInt32(exec);


    JSC::JSValue result = toJS(exec, castedThisObj->globalObject(), WTF::getPtr(imp->getActiveAttrib(program, index, ec)));
    setDOMException(exec, ec);
    return result;
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionGetActiveUniform(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    WebGLProgram* program = toWebGLProgram(args.at(0));
    unsigned index = args.at(1).toInt32(exec);


    JSC::JSValue result = toJS(exec, castedThisObj->globalObject(), WTF::getPtr(imp->getActiveUniform(program, index, ec)));
    setDOMException(exec, ec);
    return result;
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionGetAttribLocation(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    WebGLProgram* program = toWebGLProgram(args.at(0));
    const UString& name = args.at(1).toString(exec);


    JSC::JSValue result = jsNumber(exec, imp->getAttribLocation(program, name));
    return result;
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionGetBufferParameter(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->getBufferParameter(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionGetContextAttributes(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());


    JSC::JSValue result = toJS(exec, castedThisObj->globalObject(), WTF::getPtr(imp->getContextAttributes()));
    return result;
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionGetError(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());


    JSC::JSValue result = jsNumber(exec, imp->getError());
    return result;
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionGetFramebufferAttachmentParameter(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->getFramebufferAttachmentParameter(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionGetParameter(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->getParameter(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionGetProgramParameter(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->getProgramParameter(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionGetProgramInfoLog(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    WebGLProgram* program = toWebGLProgram(args.at(0));


    JSC::JSValue result = jsString(exec, imp->getProgramInfoLog(program, ec));
    setDOMException(exec, ec);
    return result;
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionGetRenderbufferParameter(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->getRenderbufferParameter(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionGetShaderParameter(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->getShaderParameter(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionGetShaderInfoLog(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    WebGLShader* shader = toWebGLShader(args.at(0));


    JSC::JSValue result = jsString(exec, imp->getShaderInfoLog(shader, ec));
    setDOMException(exec, ec);
    return result;
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionGetShaderSource(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    WebGLShader* shader = toWebGLShader(args.at(0));


    JSC::JSValue result = jsString(exec, imp->getShaderSource(shader, ec));
    setDOMException(exec, ec);
    return result;
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionGetString(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned name = args.at(0).toInt32(exec);


    JSC::JSValue result = jsString(exec, imp->getString(name));
    return result;
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionGetTexParameter(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->getTexParameter(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionGetUniform(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->getUniform(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionGetUniformLocation(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    WebGLProgram* program = toWebGLProgram(args.at(0));
    const UString& name = args.at(1).toString(exec);


    JSC::JSValue result = toJS(exec, castedThisObj->globalObject(), WTF::getPtr(imp->getUniformLocation(program, name, ec)));
    setDOMException(exec, ec);
    return result;
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionGetVertexAttrib(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->getVertexAttrib(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionGetVertexAttribOffset(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned index = args.at(0).toInt32(exec);
    unsigned pname = args.at(1).toInt32(exec);


    JSC::JSValue result = jsNumber(exec, imp->getVertexAttribOffset(index, pname));
    return result;
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionHint(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned target = args.at(0).toInt32(exec);
    unsigned mode = args.at(1).toInt32(exec);

    imp->hint(target, mode);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionIsBuffer(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    WebGLBuffer* buffer = toWebGLBuffer(args.at(0));


    JSC::JSValue result = jsBoolean(imp->isBuffer(buffer));
    return result;
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionIsEnabled(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned cap = args.at(0).toInt32(exec);


    JSC::JSValue result = jsBoolean(imp->isEnabled(cap));
    return result;
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionIsFramebuffer(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    WebGLFramebuffer* framebuffer = toWebGLFramebuffer(args.at(0));


    JSC::JSValue result = jsBoolean(imp->isFramebuffer(framebuffer));
    return result;
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionIsProgram(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    WebGLProgram* program = toWebGLProgram(args.at(0));


    JSC::JSValue result = jsBoolean(imp->isProgram(program));
    return result;
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionIsRenderbuffer(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    WebGLRenderbuffer* renderbuffer = toWebGLRenderbuffer(args.at(0));


    JSC::JSValue result = jsBoolean(imp->isRenderbuffer(renderbuffer));
    return result;
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionIsShader(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    WebGLShader* shader = toWebGLShader(args.at(0));


    JSC::JSValue result = jsBoolean(imp->isShader(shader));
    return result;
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionIsTexture(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    WebGLTexture* texture = toWebGLTexture(args.at(0));


    JSC::JSValue result = jsBoolean(imp->isTexture(texture));
    return result;
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionLineWidth(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    double width = args.at(0).toNumber(exec);

    imp->lineWidth(width);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionLinkProgram(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    WebGLProgram* program = toWebGLProgram(args.at(0));

    imp->linkProgram(program, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionPixelStorei(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned pname = args.at(0).toInt32(exec);
    int param = args.at(1).toInt32(exec);

    imp->pixelStorei(pname, param);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionPolygonOffset(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    double factor = args.at(0).toNumber(exec);
    double units = args.at(1).toNumber(exec);

    imp->polygonOffset(factor, units);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionReadPixels(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    int x = args.at(0).toInt32(exec);
    int y = args.at(1).toInt32(exec);
    unsigned width = args.at(2).toInt32(exec);
    unsigned height = args.at(3).toInt32(exec);
    unsigned format = args.at(4).toInt32(exec);
    unsigned type = args.at(5).toInt32(exec);


    JSC::JSValue result = toJS(exec, castedThisObj->globalObject(), WTF::getPtr(imp->readPixels(x, y, width, height, format, type)));
    return result;
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionReleaseShaderCompiler(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());

    imp->releaseShaderCompiler();
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionRenderbufferStorage(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned target = args.at(0).toInt32(exec);
    unsigned internalformat = args.at(1).toInt32(exec);
    unsigned width = args.at(2).toInt32(exec);
    unsigned height = args.at(3).toInt32(exec);

    imp->renderbufferStorage(target, internalformat, width, height);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionSampleCoverage(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    double value = args.at(0).toNumber(exec);
    bool invert = args.at(1).toBoolean(exec);

    imp->sampleCoverage(value, invert);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionScissor(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    int x = args.at(0).toInt32(exec);
    int y = args.at(1).toInt32(exec);
    unsigned width = args.at(2).toInt32(exec);
    unsigned height = args.at(3).toInt32(exec);

    imp->scissor(x, y, width, height);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionShaderSource(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    WebGLShader* shader = toWebGLShader(args.at(0));
    const UString& string = args.at(1).toString(exec);

    imp->shaderSource(shader, string, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionStencilFunc(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned func = args.at(0).toInt32(exec);
    int ref = args.at(1).toInt32(exec);
    unsigned mask = args.at(2).toInt32(exec);

    imp->stencilFunc(func, ref, mask);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionStencilFuncSeparate(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned face = args.at(0).toInt32(exec);
    unsigned func = args.at(1).toInt32(exec);
    int ref = args.at(2).toInt32(exec);
    unsigned mask = args.at(3).toInt32(exec);

    imp->stencilFuncSeparate(face, func, ref, mask);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionStencilMask(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned mask = args.at(0).toInt32(exec);

    imp->stencilMask(mask);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionStencilMaskSeparate(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned face = args.at(0).toInt32(exec);
    unsigned mask = args.at(1).toInt32(exec);

    imp->stencilMaskSeparate(face, mask);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionStencilOp(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned fail = args.at(0).toInt32(exec);
    unsigned zfail = args.at(1).toInt32(exec);
    unsigned zpass = args.at(2).toInt32(exec);

    imp->stencilOp(fail, zfail, zpass);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionStencilOpSeparate(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned face = args.at(0).toInt32(exec);
    unsigned fail = args.at(1).toInt32(exec);
    unsigned zfail = args.at(2).toInt32(exec);
    unsigned zpass = args.at(3).toInt32(exec);

    imp->stencilOpSeparate(face, fail, zfail, zpass);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionTexParameterf(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned target = args.at(0).toInt32(exec);
    unsigned pname = args.at(1).toInt32(exec);
    float param = args.at(2).toFloat(exec);

    imp->texParameterf(target, pname, param);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionTexParameteri(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned target = args.at(0).toInt32(exec);
    unsigned pname = args.at(1).toInt32(exec);
    int param = args.at(2).toInt32(exec);

    imp->texParameteri(target, pname, param);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionTexImage2D(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->texImage2D(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionTexSubImage2D(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->texSubImage2D(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionUniform1f(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    WebGLUniformLocation* location = toWebGLUniformLocation(args.at(0));
    float x = args.at(1).toFloat(exec);

    imp->uniform1f(location, x, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionUniform1fv(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->uniform1fv(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionUniform1i(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    WebGLUniformLocation* location = toWebGLUniformLocation(args.at(0));
    int x = args.at(1).toInt32(exec);

    imp->uniform1i(location, x, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionUniform1iv(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->uniform1iv(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionUniform2f(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    WebGLUniformLocation* location = toWebGLUniformLocation(args.at(0));
    float x = args.at(1).toFloat(exec);
    float y = args.at(2).toFloat(exec);

    imp->uniform2f(location, x, y, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionUniform2fv(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->uniform2fv(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionUniform2i(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    WebGLUniformLocation* location = toWebGLUniformLocation(args.at(0));
    int x = args.at(1).toInt32(exec);
    int y = args.at(2).toInt32(exec);

    imp->uniform2i(location, x, y, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionUniform2iv(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->uniform2iv(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionUniform3f(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    WebGLUniformLocation* location = toWebGLUniformLocation(args.at(0));
    float x = args.at(1).toFloat(exec);
    float y = args.at(2).toFloat(exec);
    float z = args.at(3).toFloat(exec);

    imp->uniform3f(location, x, y, z, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionUniform3fv(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->uniform3fv(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionUniform3i(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    WebGLUniformLocation* location = toWebGLUniformLocation(args.at(0));
    int x = args.at(1).toInt32(exec);
    int y = args.at(2).toInt32(exec);
    int z = args.at(3).toInt32(exec);

    imp->uniform3i(location, x, y, z, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionUniform3iv(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->uniform3iv(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionUniform4f(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    WebGLUniformLocation* location = toWebGLUniformLocation(args.at(0));
    float x = args.at(1).toFloat(exec);
    float y = args.at(2).toFloat(exec);
    float z = args.at(3).toFloat(exec);
    float w = args.at(4).toFloat(exec);

    imp->uniform4f(location, x, y, z, w, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionUniform4fv(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->uniform4fv(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionUniform4i(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    WebGLUniformLocation* location = toWebGLUniformLocation(args.at(0));
    int x = args.at(1).toInt32(exec);
    int y = args.at(2).toInt32(exec);
    int z = args.at(3).toInt32(exec);
    int w = args.at(4).toInt32(exec);

    imp->uniform4i(location, x, y, z, w, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionUniform4iv(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->uniform4iv(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionUniformMatrix2fv(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->uniformMatrix2fv(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionUniformMatrix3fv(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->uniformMatrix3fv(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionUniformMatrix4fv(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->uniformMatrix4fv(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionUseProgram(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    WebGLProgram* program = toWebGLProgram(args.at(0));

    imp->useProgram(program, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionValidateProgram(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    WebGLProgram* program = toWebGLProgram(args.at(0));

    imp->validateProgram(program, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionVertexAttrib1f(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned indx = args.at(0).toInt32(exec);
    float x = args.at(1).toFloat(exec);

    imp->vertexAttrib1f(indx, x);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionVertexAttrib1fv(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->vertexAttrib1fv(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionVertexAttrib2f(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned indx = args.at(0).toInt32(exec);
    float x = args.at(1).toFloat(exec);
    float y = args.at(2).toFloat(exec);

    imp->vertexAttrib2f(indx, x, y);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionVertexAttrib2fv(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->vertexAttrib2fv(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionVertexAttrib3f(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned indx = args.at(0).toInt32(exec);
    float x = args.at(1).toFloat(exec);
    float y = args.at(2).toFloat(exec);
    float z = args.at(3).toFloat(exec);

    imp->vertexAttrib3f(indx, x, y, z);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionVertexAttrib3fv(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->vertexAttrib3fv(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionVertexAttrib4f(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    unsigned indx = args.at(0).toInt32(exec);
    float x = args.at(1).toFloat(exec);
    float y = args.at(2).toFloat(exec);
    float z = args.at(3).toFloat(exec);
    float w = args.at(4).toFloat(exec);

    imp->vertexAttrib4f(indx, x, y, z, w);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionVertexAttrib4fv(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    return castedThisObj->vertexAttrib4fv(exec, args);
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionVertexAttribPointer(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    ExceptionCode ec = 0;
    unsigned indx = args.at(0).toInt32(exec);
    int size = args.at(1).toInt32(exec);
    unsigned type = args.at(2).toInt32(exec);
    bool normalized = args.at(3).toBoolean(exec);
    int stride = args.at(4).toInt32(exec);
    unsigned offset = args.at(5).toInt32(exec);

    imp->vertexAttribPointer(indx, size, type, normalized, stride, offset, ec);
    setDOMException(exec, ec);
    return jsUndefined();
}

JSValue JSC_HOST_CALL jsWebGLRenderingContextPrototypeFunctionViewport(ExecState* exec, JSObject*, JSValue thisValue, const ArgList& args)
{
    UNUSED_PARAM(args);
    if (!thisValue.inherits(&JSWebGLRenderingContext::s_info))
        return throwError(exec, TypeError);
    JSWebGLRenderingContext* castedThisObj = static_cast<JSWebGLRenderingContext*>(asObject(thisValue));
    WebGLRenderingContext* imp = static_cast<WebGLRenderingContext*>(castedThisObj->impl());
    int x = args.at(0).toInt32(exec);
    int y = args.at(1).toInt32(exec);
    unsigned width = args.at(2).toInt32(exec);
    unsigned height = args.at(3).toInt32(exec);

    imp->viewport(x, y, width, height);
    return jsUndefined();
}

// Constant getters

JSValue jsWebGLRenderingContextDEPTH_BUFFER_BIT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x00000100));
}

JSValue jsWebGLRenderingContextSTENCIL_BUFFER_BIT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x00000400));
}

JSValue jsWebGLRenderingContextCOLOR_BUFFER_BIT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x00004000));
}

JSValue jsWebGLRenderingContextFALSE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0));
}

JSValue jsWebGLRenderingContextTRUE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(1));
}

JSValue jsWebGLRenderingContextPOINTS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0000));
}

JSValue jsWebGLRenderingContextLINES(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0001));
}

JSValue jsWebGLRenderingContextLINE_LOOP(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0002));
}

JSValue jsWebGLRenderingContextLINE_STRIP(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0003));
}

JSValue jsWebGLRenderingContextTRIANGLES(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0004));
}

JSValue jsWebGLRenderingContextTRIANGLE_STRIP(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0005));
}

JSValue jsWebGLRenderingContextTRIANGLE_FAN(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0006));
}

JSValue jsWebGLRenderingContextZERO(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0));
}

JSValue jsWebGLRenderingContextONE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(1));
}

JSValue jsWebGLRenderingContextSRC_COLOR(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0300));
}

JSValue jsWebGLRenderingContextONE_MINUS_SRC_COLOR(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0301));
}

JSValue jsWebGLRenderingContextSRC_ALPHA(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0302));
}

JSValue jsWebGLRenderingContextONE_MINUS_SRC_ALPHA(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0303));
}

JSValue jsWebGLRenderingContextDST_ALPHA(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0304));
}

JSValue jsWebGLRenderingContextONE_MINUS_DST_ALPHA(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0305));
}

JSValue jsWebGLRenderingContextDST_COLOR(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0306));
}

JSValue jsWebGLRenderingContextONE_MINUS_DST_COLOR(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0307));
}

JSValue jsWebGLRenderingContextSRC_ALPHA_SATURATE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0308));
}

JSValue jsWebGLRenderingContextFUNC_ADD(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8006));
}

JSValue jsWebGLRenderingContextBLEND_EQUATION(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8009));
}

JSValue jsWebGLRenderingContextBLEND_EQUATION_RGB(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8009));
}

JSValue jsWebGLRenderingContextBLEND_EQUATION_ALPHA(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x883D));
}

JSValue jsWebGLRenderingContextFUNC_SUBTRACT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x800A));
}

JSValue jsWebGLRenderingContextFUNC_REVERSE_SUBTRACT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x800B));
}

JSValue jsWebGLRenderingContextBLEND_DST_RGB(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x80C8));
}

JSValue jsWebGLRenderingContextBLEND_SRC_RGB(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x80C9));
}

JSValue jsWebGLRenderingContextBLEND_DST_ALPHA(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x80CA));
}

JSValue jsWebGLRenderingContextBLEND_SRC_ALPHA(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x80CB));
}

JSValue jsWebGLRenderingContextCONSTANT_COLOR(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8001));
}

JSValue jsWebGLRenderingContextONE_MINUS_CONSTANT_COLOR(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8002));
}

JSValue jsWebGLRenderingContextCONSTANT_ALPHA(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8003));
}

JSValue jsWebGLRenderingContextONE_MINUS_CONSTANT_ALPHA(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8004));
}

JSValue jsWebGLRenderingContextBLEND_COLOR(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8005));
}

JSValue jsWebGLRenderingContextARRAY_BUFFER(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8892));
}

JSValue jsWebGLRenderingContextELEMENT_ARRAY_BUFFER(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8893));
}

JSValue jsWebGLRenderingContextARRAY_BUFFER_BINDING(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8894));
}

JSValue jsWebGLRenderingContextELEMENT_ARRAY_BUFFER_BINDING(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8895));
}

JSValue jsWebGLRenderingContextSTREAM_DRAW(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x88E0));
}

JSValue jsWebGLRenderingContextSTATIC_DRAW(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x88E4));
}

JSValue jsWebGLRenderingContextDYNAMIC_DRAW(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x88E8));
}

JSValue jsWebGLRenderingContextBUFFER_SIZE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8764));
}

JSValue jsWebGLRenderingContextBUFFER_USAGE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8765));
}

JSValue jsWebGLRenderingContextCURRENT_VERTEX_ATTRIB(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8626));
}

JSValue jsWebGLRenderingContextFRONT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0404));
}

JSValue jsWebGLRenderingContextBACK(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0405));
}

JSValue jsWebGLRenderingContextFRONT_AND_BACK(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0408));
}

JSValue jsWebGLRenderingContextTEXTURE_2D(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0DE1));
}

JSValue jsWebGLRenderingContextCULL_FACE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0B44));
}

JSValue jsWebGLRenderingContextBLEND(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0BE2));
}

JSValue jsWebGLRenderingContextDITHER(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0BD0));
}

JSValue jsWebGLRenderingContextSTENCIL_TEST(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0B90));
}

JSValue jsWebGLRenderingContextDEPTH_TEST(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0B71));
}

JSValue jsWebGLRenderingContextSCISSOR_TEST(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0C11));
}

JSValue jsWebGLRenderingContextPOLYGON_OFFSET_FILL(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8037));
}

JSValue jsWebGLRenderingContextSAMPLE_ALPHA_TO_COVERAGE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x809E));
}

JSValue jsWebGLRenderingContextSAMPLE_COVERAGE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x80A0));
}

JSValue jsWebGLRenderingContextNO_ERROR(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0));
}

JSValue jsWebGLRenderingContextINVALID_ENUM(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0500));
}

JSValue jsWebGLRenderingContextINVALID_VALUE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0501));
}

JSValue jsWebGLRenderingContextINVALID_OPERATION(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0502));
}

JSValue jsWebGLRenderingContextOUT_OF_MEMORY(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0505));
}

JSValue jsWebGLRenderingContextCW(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0900));
}

JSValue jsWebGLRenderingContextCCW(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0901));
}

JSValue jsWebGLRenderingContextLINE_WIDTH(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0B21));
}

JSValue jsWebGLRenderingContextALIASED_POINT_SIZE_RANGE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x846D));
}

JSValue jsWebGLRenderingContextALIASED_LINE_WIDTH_RANGE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x846E));
}

JSValue jsWebGLRenderingContextCULL_FACE_MODE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0B45));
}

JSValue jsWebGLRenderingContextFRONT_FACE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0B46));
}

JSValue jsWebGLRenderingContextDEPTH_RANGE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0B70));
}

JSValue jsWebGLRenderingContextDEPTH_WRITEMASK(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0B72));
}

JSValue jsWebGLRenderingContextDEPTH_CLEAR_VALUE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0B73));
}

JSValue jsWebGLRenderingContextDEPTH_FUNC(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0B74));
}

JSValue jsWebGLRenderingContextSTENCIL_CLEAR_VALUE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0B91));
}

JSValue jsWebGLRenderingContextSTENCIL_FUNC(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0B92));
}

JSValue jsWebGLRenderingContextSTENCIL_FAIL(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0B94));
}

JSValue jsWebGLRenderingContextSTENCIL_PASS_DEPTH_FAIL(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0B95));
}

JSValue jsWebGLRenderingContextSTENCIL_PASS_DEPTH_PASS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0B96));
}

JSValue jsWebGLRenderingContextSTENCIL_REF(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0B97));
}

JSValue jsWebGLRenderingContextSTENCIL_VALUE_MASK(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0B93));
}

JSValue jsWebGLRenderingContextSTENCIL_WRITEMASK(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0B98));
}

JSValue jsWebGLRenderingContextSTENCIL_BACK_FUNC(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8800));
}

JSValue jsWebGLRenderingContextSTENCIL_BACK_FAIL(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8801));
}

JSValue jsWebGLRenderingContextSTENCIL_BACK_PASS_DEPTH_FAIL(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8802));
}

JSValue jsWebGLRenderingContextSTENCIL_BACK_PASS_DEPTH_PASS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8803));
}

JSValue jsWebGLRenderingContextSTENCIL_BACK_REF(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8CA3));
}

JSValue jsWebGLRenderingContextSTENCIL_BACK_VALUE_MASK(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8CA4));
}

JSValue jsWebGLRenderingContextSTENCIL_BACK_WRITEMASK(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8CA5));
}

JSValue jsWebGLRenderingContextVIEWPORT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0BA2));
}

JSValue jsWebGLRenderingContextSCISSOR_BOX(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0C10));
}

JSValue jsWebGLRenderingContextCOLOR_CLEAR_VALUE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0C22));
}

JSValue jsWebGLRenderingContextCOLOR_WRITEMASK(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0C23));
}

JSValue jsWebGLRenderingContextUNPACK_ALIGNMENT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0CF5));
}

JSValue jsWebGLRenderingContextPACK_ALIGNMENT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0D05));
}

JSValue jsWebGLRenderingContextMAX_TEXTURE_SIZE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0D33));
}

JSValue jsWebGLRenderingContextMAX_VIEWPORT_DIMS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0D3A));
}

JSValue jsWebGLRenderingContextSUBPIXEL_BITS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0D50));
}

JSValue jsWebGLRenderingContextRED_BITS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0D52));
}

JSValue jsWebGLRenderingContextGREEN_BITS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0D53));
}

JSValue jsWebGLRenderingContextBLUE_BITS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0D54));
}

JSValue jsWebGLRenderingContextALPHA_BITS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0D55));
}

JSValue jsWebGLRenderingContextDEPTH_BITS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0D56));
}

JSValue jsWebGLRenderingContextSTENCIL_BITS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0D57));
}

JSValue jsWebGLRenderingContextPOLYGON_OFFSET_UNITS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x2A00));
}

JSValue jsWebGLRenderingContextPOLYGON_OFFSET_FACTOR(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8038));
}

JSValue jsWebGLRenderingContextTEXTURE_BINDING_2D(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8069));
}

JSValue jsWebGLRenderingContextSAMPLE_BUFFERS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x80A8));
}

JSValue jsWebGLRenderingContextSAMPLES(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x80A9));
}

JSValue jsWebGLRenderingContextSAMPLE_COVERAGE_VALUE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x80AA));
}

JSValue jsWebGLRenderingContextSAMPLE_COVERAGE_INVERT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x80AB));
}

JSValue jsWebGLRenderingContextNUM_COMPRESSED_TEXTURE_FORMATS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x86A2));
}

JSValue jsWebGLRenderingContextCOMPRESSED_TEXTURE_FORMATS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x86A3));
}

JSValue jsWebGLRenderingContextDONT_CARE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x1100));
}

JSValue jsWebGLRenderingContextFASTEST(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x1101));
}

JSValue jsWebGLRenderingContextNICEST(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x1102));
}

JSValue jsWebGLRenderingContextGENERATE_MIPMAP_HINT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8192));
}

JSValue jsWebGLRenderingContextBYTE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x1400));
}

JSValue jsWebGLRenderingContextUNSIGNED_BYTE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x1401));
}

JSValue jsWebGLRenderingContextSHORT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x1402));
}

JSValue jsWebGLRenderingContextUNSIGNED_SHORT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x1403));
}

JSValue jsWebGLRenderingContextINT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x1404));
}

JSValue jsWebGLRenderingContextUNSIGNED_INT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x1405));
}

JSValue jsWebGLRenderingContextFLOAT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x1406));
}

JSValue jsWebGLRenderingContextFIXED(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x140C));
}

JSValue jsWebGLRenderingContextDEPTH_COMPONENT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x1902));
}

JSValue jsWebGLRenderingContextALPHA(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x1906));
}

JSValue jsWebGLRenderingContextRGB(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x1907));
}

JSValue jsWebGLRenderingContextRGBA(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x1908));
}

JSValue jsWebGLRenderingContextLUMINANCE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x1909));
}

JSValue jsWebGLRenderingContextLUMINANCE_ALPHA(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x190A));
}

JSValue jsWebGLRenderingContextUNSIGNED_SHORT_4_4_4_4(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8033));
}

JSValue jsWebGLRenderingContextUNSIGNED_SHORT_5_5_5_1(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8034));
}

JSValue jsWebGLRenderingContextUNSIGNED_SHORT_5_6_5(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8363));
}

JSValue jsWebGLRenderingContextFRAGMENT_SHADER(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B30));
}

JSValue jsWebGLRenderingContextVERTEX_SHADER(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B31));
}

JSValue jsWebGLRenderingContextMAX_VERTEX_ATTRIBS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8869));
}

JSValue jsWebGLRenderingContextMAX_VERTEX_UNIFORM_VECTORS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8DFB));
}

JSValue jsWebGLRenderingContextMAX_VARYING_VECTORS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8DFC));
}

JSValue jsWebGLRenderingContextMAX_COMBINED_TEXTURE_IMAGE_UNITS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B4D));
}

JSValue jsWebGLRenderingContextMAX_VERTEX_TEXTURE_IMAGE_UNITS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B4C));
}

JSValue jsWebGLRenderingContextMAX_TEXTURE_IMAGE_UNITS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8872));
}

JSValue jsWebGLRenderingContextMAX_FRAGMENT_UNIFORM_VECTORS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8DFD));
}

JSValue jsWebGLRenderingContextSHADER_TYPE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B4F));
}

JSValue jsWebGLRenderingContextDELETE_STATUS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B80));
}

JSValue jsWebGLRenderingContextLINK_STATUS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B82));
}

JSValue jsWebGLRenderingContextVALIDATE_STATUS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B83));
}

JSValue jsWebGLRenderingContextATTACHED_SHADERS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B85));
}

JSValue jsWebGLRenderingContextACTIVE_UNIFORMS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B86));
}

JSValue jsWebGLRenderingContextACTIVE_UNIFORM_MAX_LENGTH(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B87));
}

JSValue jsWebGLRenderingContextACTIVE_ATTRIBUTES(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B89));
}

JSValue jsWebGLRenderingContextACTIVE_ATTRIBUTE_MAX_LENGTH(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B8A));
}

JSValue jsWebGLRenderingContextSHADING_LANGUAGE_VERSION(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B8C));
}

JSValue jsWebGLRenderingContextCURRENT_PROGRAM(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B8D));
}

JSValue jsWebGLRenderingContextNEVER(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0200));
}

JSValue jsWebGLRenderingContextLESS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0201));
}

JSValue jsWebGLRenderingContextEQUAL(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0202));
}

JSValue jsWebGLRenderingContextLEQUAL(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0203));
}

JSValue jsWebGLRenderingContextGREATER(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0204));
}

JSValue jsWebGLRenderingContextNOTEQUAL(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0205));
}

JSValue jsWebGLRenderingContextGEQUAL(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0206));
}

JSValue jsWebGLRenderingContextALWAYS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0207));
}

JSValue jsWebGLRenderingContextKEEP(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x1E00));
}

JSValue jsWebGLRenderingContextREPLACE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x1E01));
}

JSValue jsWebGLRenderingContextINCR(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x1E02));
}

JSValue jsWebGLRenderingContextDECR(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x1E03));
}

JSValue jsWebGLRenderingContextINVERT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x150A));
}

JSValue jsWebGLRenderingContextINCR_WRAP(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8507));
}

JSValue jsWebGLRenderingContextDECR_WRAP(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8508));
}

JSValue jsWebGLRenderingContextVENDOR(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x1F00));
}

JSValue jsWebGLRenderingContextRENDERER(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x1F01));
}

JSValue jsWebGLRenderingContextVERSION(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x1F02));
}

JSValue jsWebGLRenderingContextEXTENSIONS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x1F03));
}

JSValue jsWebGLRenderingContextNEAREST(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x2600));
}

JSValue jsWebGLRenderingContextLINEAR(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x2601));
}

JSValue jsWebGLRenderingContextNEAREST_MIPMAP_NEAREST(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x2700));
}

JSValue jsWebGLRenderingContextLINEAR_MIPMAP_NEAREST(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x2701));
}

JSValue jsWebGLRenderingContextNEAREST_MIPMAP_LINEAR(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x2702));
}

JSValue jsWebGLRenderingContextLINEAR_MIPMAP_LINEAR(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x2703));
}

JSValue jsWebGLRenderingContextTEXTURE_MAG_FILTER(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x2800));
}

JSValue jsWebGLRenderingContextTEXTURE_MIN_FILTER(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x2801));
}

JSValue jsWebGLRenderingContextTEXTURE_WRAP_S(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x2802));
}

JSValue jsWebGLRenderingContextTEXTURE_WRAP_T(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x2803));
}

JSValue jsWebGLRenderingContextTEXTURE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x1702));
}

JSValue jsWebGLRenderingContextTEXTURE_CUBE_MAP(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8513));
}

JSValue jsWebGLRenderingContextTEXTURE_BINDING_CUBE_MAP(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8514));
}

JSValue jsWebGLRenderingContextTEXTURE_CUBE_MAP_POSITIVE_X(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8515));
}

JSValue jsWebGLRenderingContextTEXTURE_CUBE_MAP_NEGATIVE_X(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8516));
}

JSValue jsWebGLRenderingContextTEXTURE_CUBE_MAP_POSITIVE_Y(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8517));
}

JSValue jsWebGLRenderingContextTEXTURE_CUBE_MAP_NEGATIVE_Y(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8518));
}

JSValue jsWebGLRenderingContextTEXTURE_CUBE_MAP_POSITIVE_Z(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8519));
}

JSValue jsWebGLRenderingContextTEXTURE_CUBE_MAP_NEGATIVE_Z(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x851A));
}

JSValue jsWebGLRenderingContextMAX_CUBE_MAP_TEXTURE_SIZE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x851C));
}

JSValue jsWebGLRenderingContextTEXTURE0(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84C0));
}

JSValue jsWebGLRenderingContextTEXTURE1(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84C1));
}

JSValue jsWebGLRenderingContextTEXTURE2(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84C2));
}

JSValue jsWebGLRenderingContextTEXTURE3(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84C3));
}

JSValue jsWebGLRenderingContextTEXTURE4(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84C4));
}

JSValue jsWebGLRenderingContextTEXTURE5(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84C5));
}

JSValue jsWebGLRenderingContextTEXTURE6(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84C6));
}

JSValue jsWebGLRenderingContextTEXTURE7(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84C7));
}

JSValue jsWebGLRenderingContextTEXTURE8(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84C8));
}

JSValue jsWebGLRenderingContextTEXTURE9(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84C9));
}

JSValue jsWebGLRenderingContextTEXTURE10(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84CA));
}

JSValue jsWebGLRenderingContextTEXTURE11(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84CB));
}

JSValue jsWebGLRenderingContextTEXTURE12(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84CC));
}

JSValue jsWebGLRenderingContextTEXTURE13(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84CD));
}

JSValue jsWebGLRenderingContextTEXTURE14(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84CE));
}

JSValue jsWebGLRenderingContextTEXTURE15(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84CF));
}

JSValue jsWebGLRenderingContextTEXTURE16(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84D0));
}

JSValue jsWebGLRenderingContextTEXTURE17(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84D1));
}

JSValue jsWebGLRenderingContextTEXTURE18(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84D2));
}

JSValue jsWebGLRenderingContextTEXTURE19(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84D3));
}

JSValue jsWebGLRenderingContextTEXTURE20(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84D4));
}

JSValue jsWebGLRenderingContextTEXTURE21(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84D5));
}

JSValue jsWebGLRenderingContextTEXTURE22(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84D6));
}

JSValue jsWebGLRenderingContextTEXTURE23(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84D7));
}

JSValue jsWebGLRenderingContextTEXTURE24(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84D8));
}

JSValue jsWebGLRenderingContextTEXTURE25(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84D9));
}

JSValue jsWebGLRenderingContextTEXTURE26(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84DA));
}

JSValue jsWebGLRenderingContextTEXTURE27(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84DB));
}

JSValue jsWebGLRenderingContextTEXTURE28(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84DC));
}

JSValue jsWebGLRenderingContextTEXTURE29(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84DD));
}

JSValue jsWebGLRenderingContextTEXTURE30(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84DE));
}

JSValue jsWebGLRenderingContextTEXTURE31(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84DF));
}

JSValue jsWebGLRenderingContextACTIVE_TEXTURE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84E0));
}

JSValue jsWebGLRenderingContextREPEAT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x2901));
}

JSValue jsWebGLRenderingContextCLAMP_TO_EDGE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x812F));
}

JSValue jsWebGLRenderingContextMIRRORED_REPEAT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8370));
}

JSValue jsWebGLRenderingContextFLOAT_VEC2(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B50));
}

JSValue jsWebGLRenderingContextFLOAT_VEC3(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B51));
}

JSValue jsWebGLRenderingContextFLOAT_VEC4(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B52));
}

JSValue jsWebGLRenderingContextINT_VEC2(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B53));
}

JSValue jsWebGLRenderingContextINT_VEC3(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B54));
}

JSValue jsWebGLRenderingContextINT_VEC4(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B55));
}

JSValue jsWebGLRenderingContextBOOL(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B56));
}

JSValue jsWebGLRenderingContextBOOL_VEC2(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B57));
}

JSValue jsWebGLRenderingContextBOOL_VEC3(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B58));
}

JSValue jsWebGLRenderingContextBOOL_VEC4(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B59));
}

JSValue jsWebGLRenderingContextFLOAT_MAT2(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B5A));
}

JSValue jsWebGLRenderingContextFLOAT_MAT3(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B5B));
}

JSValue jsWebGLRenderingContextFLOAT_MAT4(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B5C));
}

JSValue jsWebGLRenderingContextSAMPLER_2D(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B5E));
}

JSValue jsWebGLRenderingContextSAMPLER_CUBE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B60));
}

JSValue jsWebGLRenderingContextVERTEX_ATTRIB_ARRAY_ENABLED(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8622));
}

JSValue jsWebGLRenderingContextVERTEX_ATTRIB_ARRAY_SIZE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8623));
}

JSValue jsWebGLRenderingContextVERTEX_ATTRIB_ARRAY_STRIDE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8624));
}

JSValue jsWebGLRenderingContextVERTEX_ATTRIB_ARRAY_TYPE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8625));
}

JSValue jsWebGLRenderingContextVERTEX_ATTRIB_ARRAY_NORMALIZED(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x886A));
}

JSValue jsWebGLRenderingContextVERTEX_ATTRIB_ARRAY_POINTER(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8645));
}

JSValue jsWebGLRenderingContextVERTEX_ATTRIB_ARRAY_BUFFER_BINDING(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x889F));
}

JSValue jsWebGLRenderingContextIMPLEMENTATION_COLOR_READ_TYPE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B9A));
}

JSValue jsWebGLRenderingContextIMPLEMENTATION_COLOR_READ_FORMAT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B9B));
}

JSValue jsWebGLRenderingContextCOMPILE_STATUS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B81));
}

JSValue jsWebGLRenderingContextINFO_LOG_LENGTH(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B84));
}

JSValue jsWebGLRenderingContextSHADER_SOURCE_LENGTH(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8B88));
}

JSValue jsWebGLRenderingContextSHADER_COMPILER(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8DFA));
}

JSValue jsWebGLRenderingContextSHADER_BINARY_FORMATS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8DF8));
}

JSValue jsWebGLRenderingContextNUM_SHADER_BINARY_FORMATS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8DF9));
}

JSValue jsWebGLRenderingContextLOW_FLOAT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8DF0));
}

JSValue jsWebGLRenderingContextMEDIUM_FLOAT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8DF1));
}

JSValue jsWebGLRenderingContextHIGH_FLOAT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8DF2));
}

JSValue jsWebGLRenderingContextLOW_INT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8DF3));
}

JSValue jsWebGLRenderingContextMEDIUM_INT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8DF4));
}

JSValue jsWebGLRenderingContextHIGH_INT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8DF5));
}

JSValue jsWebGLRenderingContextFRAMEBUFFER(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8D40));
}

JSValue jsWebGLRenderingContextRENDERBUFFER(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8D41));
}

JSValue jsWebGLRenderingContextRGBA4(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8056));
}

JSValue jsWebGLRenderingContextRGB5_A1(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8057));
}

JSValue jsWebGLRenderingContextRGB565(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8D62));
}

JSValue jsWebGLRenderingContextDEPTH_COMPONENT16(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x81A5));
}

JSValue jsWebGLRenderingContextSTENCIL_INDEX(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x1901));
}

JSValue jsWebGLRenderingContextSTENCIL_INDEX8(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8D48));
}

JSValue jsWebGLRenderingContextRENDERBUFFER_WIDTH(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8D42));
}

JSValue jsWebGLRenderingContextRENDERBUFFER_HEIGHT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8D43));
}

JSValue jsWebGLRenderingContextRENDERBUFFER_INTERNAL_FORMAT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8D44));
}

JSValue jsWebGLRenderingContextRENDERBUFFER_RED_SIZE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8D50));
}

JSValue jsWebGLRenderingContextRENDERBUFFER_GREEN_SIZE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8D51));
}

JSValue jsWebGLRenderingContextRENDERBUFFER_BLUE_SIZE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8D52));
}

JSValue jsWebGLRenderingContextRENDERBUFFER_ALPHA_SIZE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8D53));
}

JSValue jsWebGLRenderingContextRENDERBUFFER_DEPTH_SIZE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8D54));
}

JSValue jsWebGLRenderingContextRENDERBUFFER_STENCIL_SIZE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8D55));
}

JSValue jsWebGLRenderingContextFRAMEBUFFER_ATTACHMENT_OBJECT_TYPE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8CD0));
}

JSValue jsWebGLRenderingContextFRAMEBUFFER_ATTACHMENT_OBJECT_NAME(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8CD1));
}

JSValue jsWebGLRenderingContextFRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8CD2));
}

JSValue jsWebGLRenderingContextFRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8CD3));
}

JSValue jsWebGLRenderingContextCOLOR_ATTACHMENT0(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8CE0));
}

JSValue jsWebGLRenderingContextDEPTH_ATTACHMENT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8D00));
}

JSValue jsWebGLRenderingContextSTENCIL_ATTACHMENT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8D20));
}

JSValue jsWebGLRenderingContextNONE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0));
}

JSValue jsWebGLRenderingContextFRAMEBUFFER_COMPLETE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8CD5));
}

JSValue jsWebGLRenderingContextFRAMEBUFFER_INCOMPLETE_ATTACHMENT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8CD6));
}

JSValue jsWebGLRenderingContextFRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8CD7));
}

JSValue jsWebGLRenderingContextFRAMEBUFFER_INCOMPLETE_DIMENSIONS(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8CD9));
}

JSValue jsWebGLRenderingContextFRAMEBUFFER_UNSUPPORTED(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8CDD));
}

JSValue jsWebGLRenderingContextFRAMEBUFFER_BINDING(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8CA6));
}

JSValue jsWebGLRenderingContextRENDERBUFFER_BINDING(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x8CA7));
}

JSValue jsWebGLRenderingContextMAX_RENDERBUFFER_SIZE(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x84E8));
}

JSValue jsWebGLRenderingContextINVALID_FRAMEBUFFER_OPERATION(ExecState* exec, const Identifier&, const PropertySlot&)
{
    return jsNumber(exec, static_cast<int>(0x0506));
}


}

#endif // ENABLE(3D_CANVAS)
